#INCLUDE 'Protheus.ch'
#INCLUDE 'TOPConn.ch'
#INCLUDE 'Rwmake.ch'
#include "TbiConn.ch"
#include "TbiCode.ch"  
#Include "AP5MAIL.ch"   
#DEFINE ENTER Chr(13)+Chr(10)

/*
parametro HN_NFESUP contem o email de notifica'c~ao de erros na importacao do xml.

*/

/*BEGINDOC
//Ŀ
//Esse arquivo contm funoes responsveis pelo funcionamento da opo de importao de XML de Nota Fiscal Eletronica
//
ENDDOC*/

User Function COMMI010()
Local clPar     := "MTA140I"
Private cIniFile	:= GetADV97()
Private cStartPath 	:= GetPvProfString(GetEnvServer(),"StartPath","ERROR", cIniFile )+'NFE\ENTRADA\'+SM0->M0_CODIGO+SM0->M0_CODFIL+"\"
Private cStartLido	:= Trim(cStartPath)+"ARQUIVO_XML\"
Private c3StartPath	:= cStartLido+SM0->M0_CODIGO+SM0->M0_CODFIL+"\"
Private cStartError	:= Trim(cStartPath)+"ERRO\"

//CRIA DIRETORIOS
MakeDir(GetPvProfString(GetEnvServer(),"StartPath","ERROR", cIniFile )+'NFE\')
MakeDir(GetPvProfString(GetEnvServer(),"StartPath","ERROR", cIniFile )+'NFE\ENTRADA\')
MakeDir(Trim(cStartPath)) //CRIA DIRETOTIO ENTRADA
MakeDir(cStartLido) //CRIA DIRETORIO ARQUIVOS IMPORTADOS
MakeDir(c3StartPath) //CRIA DIRETOTIO MES
MakeDir(cStartError) //CRIA DIRETORIO ERRO

dbSelectArea("SF1")
dbSeek(xfilial("SF1"))

If Pergunte(clPar,.T.,"")
	MsgRun(("Aguarde..."+Space(1)+"Criando Interface"),"Aguarde...",{|| MontaBrw() } )
EndIf
//Restaura grupo de perguntas da rotina MATA140.
Pergunte("MTA140",.F.)

Return Nil


/*

Ĵ
Descrio |Funcao retorna objeto com cor do farol                            
Ĵ
ParametrosclStatus = Status do registro (SDT->DT_STATUS)                    
Ĵ
Retorno   olCor = LoadBitmap(GetResources(),'COR')                          
Ĵ
 Uso      	MontaBrw                                                        
ٱ

*/
Static Function SelCor(clStatus)

Local olCor := NIL

Do Case
	// STATUS = PROCESSADA PELO PROTHEUS
	Case clStatus == 'P'
		olCor:=LoadBitmap(GetResources(),'BR_VERMELHO')
	Case clStatus == 'R' //REJEITADO NA RECEITA
		olCor:=LoadBitmap(GetResources(),'BR_PRETO')
		// STATUS = LIBERADO PARA PRE-NOTA
	OtherWise
		olCor:=LoadBitmap(GetResources(),'BR_VERDE')
EndCase
Return olCor

/*

Ĵ
Descrio |Funcao monta o aHeader do browse principal com os itens da SDS    
Ĵ
Retorno    alHdRet = Array com o nome dos campos selecionados no dicionario 
Ĵ
 Uso       MontaBrw	                                                        
ٱ

*/
Static Function MontHdr()

Local alHdRet := {}

aAdd(alHdRet,"DS_STATUS")
dbSelectArea("SX3")
DbSetOrder(1)
dbGoTop()
SX3->(DbSeek("SDS"))

While !EOF() .AND. SX3->X3_ARQUIVO == "SDS"
	If (SX3->X3_BROWSE=="S") .AND. (cNivel>=SX3->X3_NIVEL) .AND. (!(ALLTRIM(SX3->X3_CAMPO) $ "DS_FILIAL/DS_STATUS"))
		Aadd(alHdRet,SX3->X3_CAMPO)
	EndIf
	DbSkip()
EndDo
aAdd(alHdRet,"DS_CHAVENF")

Return alHdRet

/*

Descrio | Funcao verifica os itens a carregar no browse perante os campos  
          | e parametro.							                            
          | Adciona os registro em um array (alRet) que e usado como retorno 
Ĵ
ParametrosalHdr   := Array com os campos do browse                          
          |alParam1 := Array com os possiveis parametros, sendo as posicoes   
          | [1]-{1 , " " } // 1 - Liberado para pre-nota      			    
          | [2]-{2 , "P" } // 2 - Processada pelo Protheus				    
Ĵ
Retorno    alRet = Array contendo os registros                              
Ĵ
 Uso       AtuBrw	                                                        
ٱ

*/

Static Function CarItens(alHdr,alParam1)

Local alRet     := {}
Local cArqInd   := ""
Local cChaveInd := ""
Local cQuery	:= ""
Local nlK       := 0
Local nIndice	:= 0

Pergunte("MTA140I",.f.)
dbSelectArea("SDS")
dbSetOrder(1)

cArqInd   := CriaTrab(, .F.)
cChaveInd := IndexKey()
cQuery := 'DS_FILIAL >="'+xFilial("SDS")+'" .And.'
cQuery += 'DS_DOC    >="'+mv_par01+'".And.DS_DOC   <="'+mv_par02+'".And.'
cQuery += 'DS_SERIE  >="'+mv_par03+'".And.DS_SERIE <="'+mv_par04+'".and.'
cQuery += IF(MV_PAR11 = 1,'.T.','DS_STATUS <> "P"')
           
IndRegua("SDS", cArqInd, cChaveInd, , cQuery,"Criando indice de trabalho" ) //"Criando indice de trabalho"

nIndice := RetIndex("SDS") + 1
#IFNDEF TOP
	dbSetIndex(cArqInd + OrdBagExt())
#ENDIF
dbSetOrder(nIndice)
SDS->(MsSeek(xFilial("SDS")))

While SDS->(!EOF())
	AADD(alRet,Array(Len(alHdr)))
	For nlk:=1 to Len(alHdr)
		If alHdr[nlk,4]=="V"
			alRet[Len(alRet),nlk]:=CriaVar(alHdr[nlk,2])
		Else
			alRet[Len(alRet),nlk]:=FieldGet(FieldPos(alHdr[nlk,2]))
		EndIf
	Next nlk
	SDS->(dbSKip())
End

SDS->(DbClearFil())
RetIndex("SDS")
Return alRet


/*

Descriao | Monta o Browse principal que exibi os schemas importados         
Ĵ
Parametros clRaiz = Diretorio/Local arquivos raiz                           
          | clDest = Diretorio/Local arquivos lidos                          
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       A140XMLNFe	                                                    
ٱ

*/
Static Function MontaBrw()
Local _alSize    	:= MsAdvSize()
Local _alHdCps 		:= {}
Local _alHdSize      := {}
Local alCpos1        := {}
Local _alItBx        := {}
Local alParam1       := {}
Local alCpHd        := MontHdr()
Local clLine1        := ""
Local clLegenda     := ""
Local clFilBrw 		:= ""
Local cTCFilterEX	:= "TCFilterEX"
Local nlTl1     	:= _alSize[1]
Local nlTl2    		:= _alSize[2]
Local nlTl3    		:= _alSize[1]+450
Local nlTl4     	:= _alSize[2]+790
Local nlCont        := 0
Local nlPosCFor     := 0
Local nlPosLoja     := 0
Local nlPosNum      := 0
Local nlPosSer      := 0
Local nlPosCHNF		:= 0
Local olLBox1    	:= NIL
Local olBtLeg       := NIL
Local olBtFiltro    := NIL
Local olBtImpM		:= NIL

Private _opDlgPcp	:= NIL
Private opBtVis     := NIL
Private opBtImp     := NIL
Private opBtPed     := NIL
Private cIdEnt
//Ŀ
// Array alParam1 recebe parametros para filtro           
//
aAdd(alParam1,{1 , " " }) // 1 - Liberado para pre-nota
aAdd(alParam1,{2 , "P" }) // 2 - Processada pelo Protheus

//Ŀ
// Monta o Header com os titulos do TWBrowse             
//
dbSelectArea("SX3")
dbSetOrder(2)
For nlCont	:= 1 to Len(alCpHd)
	If MsSeek(alCpHd[nlCont])
		If alCpHd[nlCont] == "DS_STATUS"
			AADD(_alHdCps," ")
			AADD(_alHdSize,1)
		Else
			AADD(_alHdCps,AllTrim(X3Titulo()))
			AADD(_alHdSize,Iif(nlCont==1,200,CalcFieldSize(SX3->X3_TIPO,SX3->X3_TAMANHO,SX3->X3_DECIMAL,SX3->X3_PICTURE,X3Titulo())))
		EndIf
		AADD(alCpos1,{AllTrim(X3Titulo()),SX3->X3_CAMPO,SX3->X3_TIPO,SX3->X3_CONTEXT,SX3->X3_PICTURE})
	EndIf
Next

//Ŀ
// Verifica as posicoes/ordens dos campos no array       
//
nlPosCFor := Ascan(alCpos1,{|x|Alltrim(X[2])=="DS_FORNEC"})
nlPosLoja := Ascan(alCpos1,{|x|Alltrim(X[2])=="DS_LOJA"})
nlPosNum  := Ascan(alCpos1,{|x|Alltrim(X[2])=="DS_DOC"})
nlPosSer  := Ascan(alCpos1,{|x|Alltrim(X[2])=="DS_SERIE"})
nlPosCHNF := Ascan(alCpos1,{|x|Alltrim(X[2])=="DS_CHAVENF"})


//Ŀ
// Colunas da ListBox/TWBrowse                                				
//
clLine1 := "{|| {SelCor(_alItBx[olLBox1:nAt,1]) ,"
For nlCont:=2 To Len(alCpos1)
	clLine1 += "_alItBx[olLBox1:nAt,"+AllTrim(Str(nlCont))+"]"+IIf(nlCont<Len(alCpos1),",","")
Next nX
clLine1 += "}}"


// Ŀ
// | Monta Legenda  |
// 
clLegenda := "BrwLegenda('Nf-e Disponveis','Legenda' ,{{'BR_VERDE'    ,'Apto a gerar Pr nota'}";
+" ,{'BR_VERMELHO' ,'Documento Gerado'}";
+" ,{'BR_PRETO' ,'Cancelado Receita'}";
+" })"

cIdEnt := U_WSAT01GetIdEnt()


DEFINE MSDIALOG _opDlgPcp TITLE "Nf-e Disponveis" From nlTl1,nlTl2 to nlTl3,nlTl4 PIXEL

// Ŀ
// |  BOTOES    |
// 

/*
opBtPed := TButton():New(nlTl1+203,_alSize[2]+000,"Grava XML",_opDlgPcp,{|| U_GRVXML( 1,	_alItBx[olLBox1:nAt,nlPosCFor] ,;		// | Cod. Fornecedor
_alItBx[olLBox1:nAt,nlPosLoja] ,;			// | Loja
_alItBx[olLBox1:nAt,nlPosNum ] ,;			// | Numero Doc.
_alItBx[olLBox1:nAt,nlPosSer])} ;			// | Serie
,041,014,,,,.T.  )
*/

//opBtPed := TButton():New(nlTl1+203,_alSize[2]+000,"Email Manual",_opDlgPcp,{|| U_CFGMI003() } ,035,014,,,,.T.  )

// Gerar Pre Nota

opBtImp := TButton():New(nlTl1+203,_alSize[2]+000,"Gerar Pre Nota",_opDlgPcp,{|| (U_CFGMI005(	3, ;								// | Opcao
_alItBx[olLBox1:nAt,nlPosCFor],;     		// | Cod. Fornec./Cli.
_alItBx[olLBox1:nAt,nlPosLoja],;   		// | Loja
_alItBx[olLBox1:nAt,nlPosNum],;    	   	// | Num. Nota Fiscal
_alItBx[olLBox1:nAt,nlPosSer]) ,; 		// | Serie
(olLBox1:=AtuBrw(olLBox1,_alItBx,clLine1,alCpos1,alParam1)),;
(olLBox1:Refresh()),(olLBox1:bGoTop),;
(Iif(!Empty(olLBox1:aArray),AtuBtn1(olLBox1:aArray[olLBox1:nAt,1]),)))};
,040,014,,,,.T.  )

@ (nlTl1+203),(_alSize[2]+50) 	BUTTON "Exclui XML" SIZE 35,14 OF _opDlgPcp PIXEL ACTION (U_DELXML( 1,	_alItBx[olLBox1:nAt,nlPosCFor] ,;		// | Cod. Fornecedor
_alItBx[olLBox1:nAt,nlPosLoja] ,;			// | Loja
_alItBx[olLBox1:nAt,nlPosNum ] ,;			// | Numero Doc.
_alItBx[olLBox1:nAt,nlPosSer]),AtuBrw(olLBox1,_alItBx,clLine1,alCpos1,alParam1))

@ (nlTl1+203),(_alSize[2]+110) 	BUTTON "Exp XML" SIZE 35,14 OF _opDlgPcp PIXEL ACTION U_GRVXML( 1, ;
_alItBx[olLBox1:nAt,nlPosCFor] ,;		// | Cod. Fornecedor
_alItBx[olLBox1:nAt,nlPosLoja] ,;			// | Loja
_alItBx[olLBox1:nAt,nlPosNum ] ,;			// | Numero Doc.
_alItBx[olLBox1:nAt,nlPosSer])

// Visualizar //Static Function ExecTela(nlOpc,clCodFor,clLoja,clNota,clSerie,olLBox1)
opBtVis := TButton():New(nlTl1+203,_alSize[2]+150,"Visualizar",_opDlgPcp,{|| (ExecTela(	2, ;
_alItBx[olLBox1:nAt,nlPosCFor],;			// | Cod. Fornec./Cli.
_alItBx[olLBox1:nAt,nlPosLoja],;	  		// | Loja_alItBx[olLBox1:nAt,nlPosNum],;	   		// | Num. Nota Fiscal
_alItBx[olLBox1:nAt,nlPosNum ] ,;			// | Numero Doc.
_alItBx[olLBox1:nAt,nlPosSer])   ) };		// | Serie
,035,014,,,,.T.  )

// Legenda
olBtLeg := TButton():New(nlTl1+203,_alSize[2]+190,"Legenda",_opDlgPcp, {|| &clLegenda } ,035,014,,,,.T.  )

// Filtro
olBtFiltro := TButton():New(nlTl1+203,_alSize[2]+230,"Filtro",_opDlgPcp, {|| FiltraBrw(olLBox1,_alItBx,clLine1,alCpos1,alParam1, @clFilBrw) } ,035,014,,,,.T.  )

// Importao manual
olBtImpM := TButton():New(nlTl1+203,_alSize[2]+270,"Selec.XML",_opDlgPcp, {|| ImpManual(),(olLBox1:=AtuBrw(olLBox1,_alItBx,clLine1,alCpos1,alParam1)) } ,035,014,,,,.T.  )


@ (nlTl1+203),(_alSize[2]+310) 	BUTTON "Cons.NFE" SIZE 35,14 OF _opDlgPcp PIXEL ACTION (ConsNFeChave(_alItBx[olLBox1:nAt,nlPosCHNF],cIdEnt))

// Sair / Fechar
@ (nlTl1+203),(_alSize[2]+350) 	BUTTON "Sair" SIZE 35,14 OF _opDlgPcp PIXEL ACTION Eval({|| DbSelectArea("SDS"), &cTCFilterEX.("",1), _opDlgPcp:END()})

// Ŀ
// | TW BROWSE - NOTAS  |
// 
&cTCFilterEX.("",1)
olLBox1 := TwBrowse():New(nlTl1+10,nlTl2-2,nlTl3-75,nlTl4-620,,_alHdCps,_alHdSize,_opDlgPcp,,,,,{|| Iif(!Empty(olLBox1:aArray),Eval(opBtVis:BACTION),) } ,,,,,,,.F.,,.T.,,.F.,,,)
olLBox1 := AtuBrw(olLBox1,_alItBx,clLine1,alCpos1,alParam1)
olLBox1:BChange:= Iif(!Empty(olLBox1:aArray), {|| AtuBtn1(olLBox1:aArray[olLBox1:nAt,1]) } , {|| olLBox1:Refresh()  } )
ACTIVATE DIALOG _opDlgPcp CENTERED



Return NIL
/*

Descriao | Realiza a importacao manual do arquivo selecionado pelo usuario  
          | utilizando a rotina automatica de importacao da NF-e		        
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       MontaBrw		                                                    
ٱ

*/
Static Function ImpManual()

nOpcao :=Aviso( "Modo de importao", "Escolha boto 'Arquivo' para para importar somente 1 arquivo XML, 'Pasta' para importa multiplos arquivos de uma pasta", {"Arquivo", "Pasta"}, 2)
if nOpcao = 1
	cPathR:= cGetFile("Arquivo XML (*.xml)  | *.xml | ","Selecione o Arquivo",0,"c:\",.T.,GETF_LOCALFLOPPY + GETF_LOCALHARD + GETF_NETWORKDRIVE)
else
	cPathR:= cGetFile("\","Selecione Diretorio p/ Gravar os Arquivos",,,,GETF_RETDIRECTORY+GETF_LOCALHARD+GETF_LOCALFLOPPY+GETF_NETWORKDRIVE)
	aDirLoc := DIRECTORY( cPathR+"*.XML" , )
endif

cFile := cPathR

If !Empty(cPathR)
	if nOpcao = 1
		While At("\",cFile) > 0
			cFile := Substr(cFile,At("\",cFile)+1)
		End
		aDirLoc := {{cFile ,""}}
	endif
	
	for nL:= 1 to len(aDirLoc)
		cFile := ALLTRIM(aDirLoc[nL,1])
		If !":\" $ cPathR //-- Arquivo do servidor
			Copy File &(cPathR+if(nOpcao=1,"",cFile)) TO &(cStartPath +cFile)
		Else //-- Arquivo do client
			CpyT2S(cPathR+if(nOpcao=1,"",cFile),cStartPath)
		EndIf
		//-- Chama funcao de import
		MsAguarde({|| U_ReadXML(cFile,.F.)},"Aguarde","Importando dados do arquivo XML...",.F.)
	next nL
EndIf

Return( Nil )


/*

Descriao | Atualiza botoes na mudanca de registro. Se o status for          
          | P = Processada Desabilita os botoes de Selecionar Pedido, 		
			 | Ver. Schema e Importar.											
Ĵ
Parametros clStatus = Status do registro selecioado                         
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       MontaBrw	                                                        
ٱ

*/
Static Function FiltraBrw(olLBox1,_alItBx,clLine1,alCpos1,alParam1,clFilBrw )
Local cTCFilterEX 	:= "TCFilterEX"
Local aArea			:= GetArea()
clFilBrw := BuildExpr("SDS",,clFilBrw)

DbSelectArea("SDS")
&cTCFilterEX.(clFilBrw,1)

AtuBrw(olLBox1,_alItBx,clLine1,alCpos1,alParam1)

RestArea(aArea)
Return Nil
/*

Descriao | Atualiza botoes na mudanca de registro. Se o status for          
          | P = Processada Desabilita os botoes de Selecionar Pedido, 		
			 | Ver. Schema e Importar.											
Ĵ
Parametros clStatus = Status do registro selecioado                         
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       MontaBrw	                                                        
ٱ

*/
Static Function AtuBtn1(clStatus)


If (clStatus$"P")
//	opBtPed:Disable()
//	opBtImp:Disable()
Else
//	opBtPed:Enable()
//	opBtImp:Enable()
EndIf


Return Nil
/*

Descriao | Atualiza a tela apos gerar pre nota                              
Ĵ
Parametros olLBox1  = Objeto do TwBrowse (ListBOx)                           
          | _alItBx  = Array contendo os itens do ListBox                     
          | clLine1  = String do BLoco de Codigo bLine                        
          | alCpos1  = Campos exibidos no ListBox                             
          | alParam1 = Array com informacoes do filtro                        
          |           [ 1 ] - Parametro escolhido                            
          |           [ 2 ] - String para sua representacao Exemplo: "T"     
Ĵ
Retorno    olLBox1 = ListBox atualizado                                      
Ĵ
 Uso       FiltraBrw, MontaBrw                                              
ٱ

*/
Static Function AtuBrw(olLBox1,_alItBx,clLine1,alCpos1,alParam1)
//Ŀ
// Carrega o array com as informacoes dos registros      
//
_alItBx:=CarItens(alCpos1, alParam1)
olLBox1:SetArray(_alItBx)
olLBox1:bLine := Iif(!Empty(_alItBx),&clLine1, {|| Array(Len(alCpos1))} )
If EmpTy(olLBox1:aArray)
	//opBtPed:Disable()
	//opBtVis:Disable()
	//opBtImp:Disable()
EndIf
Return olLBox1

/*

Descriao | Monta tela para selecao do pedido de compra                      
Ĵ
Parametros clCodFor  = Cod. Fornec./Cli.                                    
          | clLoja    = Loja                                                 
          | clNota    = Num. Nota                                            
          | clSerie   = Serie da Nota                                        
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       MontaBrw	                                                        
ٱ

*/
Static Function SelePed(clCodFor,clLoja,clNota,clSerie)

Local nlCont        := 0
Local clDescProd    := ""
Local clTipo        := ""
Local alNome        := {}
Local alRetRef      := {}
Local olBtSch       := NIL
Local olBDsfz       := NIL
Local olFont        := TFont ():New(,,-11,.T.,.T.,5,.T.,5,.F.,.F.)
Local _alSize    	:= MsAdvSize()
Local nlTl1     	:= _alSize[1]
Local nlTl2    		:= _alSize[2]
Local nlTl3    		:= _alSize[1]+300
Local nlTl4     	:= _alSize[2]+520
Local alItens       := {}
Local alCabec       := {"DT_ITEM","DT_COD","DT_PRODFOR","B1_DESC"}
Local alHdIt        := {}
Local alTamHd       := {}
Private _opBoxIt    := NIL
Private _opSPeDlg	:= NIL

dbSelectArea("SX3")
SX3->(dbSetOrder(2))
For nlCont	:= 1 to Len(alCabec)
	If MsSeek(alCabec[nlCont])
		AADD(alHdIt,AllTrim(X3Titulo()))
		AADD(alTamHd,CalcFieldSize(SX3->X3_TIPO,SX3->X3_TAMANHO,SX3->X3_DECIMAL,SX3->X3_PICTURE,X3Titulo()) )
	EndIf
Next

// Ŀ
// | POSICIONA PARA BUSCAR NOME DO FORNECEDOR/CLIENTE |
// 
dbSelectArea("SDS")
SDS->(dbSetOrder(1))
SDS->(dbSeek(xFilial("SDS")+clNota+clSerie+clCodFor+clLoja))
If SDS->DS_TIPO == 'N'
	dbSelectArea("SA2")
	dbSetOrder(1)
	aAdd(alNome,{"SA2","A2_NOME","Fornecedor"})
	clTipo:="F"
Else
	Aviso("Ateno","Tipo de Nota Fiscal no permitida",{"Ok"})
	Return
EndIf
&(alNome[1,1])->(dbGoTop())

DEFINE MSDIALOG _opSPeDlg TITLE "Selecionar Pedido" From nlTl1,nlTl2 to nlTl3,nlTl4 PIXEL

// Box
@(nlTl1+10),nlTl2 to (nlTl1+35),(nlTl2+237) PIXEL OF _opSPeDlg
@(nlTl1+14),(nlTl2+005) Say "Nota Fiscal:"+clNota Font olFont Pixel Of _opSPeDlg
@(nlTl1+14),(nlTl2+180) Say "Serie :"+clSerie Font olFont Pixel Of _opSPeDlg
@(nlTl1+23),(nlTl2+005) Say alNome[1,3]+clCodFor+" - "+ Posicione(alNome[1,1],1,(xFilial(alNome[1,1])+clCodFor+clLoja),alNome[1,2])      Font olFont Pixel Of _opSPeDlg

// Ŀ
// | CARREGA OS ITENS |
// 
dbSelectArea("SDT")
SDT->(dbSetOrder(2))
If SDT->(dbSeek(xFilial("SDT")+PadR(clCodFor,TamSx3("DT_FORNEC")[1])+PadR(clLoja,TamSx3("DT_LOJA")[1])+PadR(clNota,TamSx3("DT_DOC")[1])+PadR(clSerie,TamSx3("DT_SERIE")[1]) ))
	dbSelectArea("SB1")
	SB1->(dbSetOrder(1))
	While SDT->(!EOF()) .AND. (SDT->DT_FORNEC==clCodFor) .AND. (SDT->DT_LOJA==clLoja) .AND. (SDT->DT_DOC==clNota) .AND. (SDT->DT_SERIE==clSerie)
		clDescProd:= Iif(!Empty(SDT->DT_COD),Posicione("SB1",1,(xFilial("SB1")+PadR(SDT->DT_COD,TamSX3("B1_COD")[1])),"B1_DESC"),SDT->DT_DESCFOR)
		aAdd(alItens,{SDT->DT_ITEM , SDT->DT_COD, SDT->DT_PRODFOR ,clDescProd })
		clDescProd:=""
		SDT->(dbSkip())
	EndDo
EndIf

// Ŀ
// | TW BROWSE - ITENS DA NOTA |
// 	 //larg   //alt
_opBoxIt := TwBrowse():New(nlTl1+40,nlTl2,nlTl4-295,nlTl3-217,,alHdIt,alTamHd,_opSPeDlg,,,,,,,,,,,,.F.,,.T.,,.F.,,,)
_opBoxIt:SetArray(alItens)
_opBoxIt:bLine := {|| {alItens[_opBoxIt:nAt,1],alItens[_opBoxIt:nAt,2],alItens[_opBoxIt:nAt,3], alItens[_opBoxIt:nAt,4]} }

// Ŀ
// |  BOTOES    |
// 
olBtSch  := TButton():New(nlTl1+132,nlTl2,"Selecionar Pedidos",_opSPeDlg,{||  MsgRun("Aguarde","Selecionando Registros..." ,{|| ProcPCxNFe(clCodFor,clLoja,clNota,clSerie,alItens,alItens[_opBoxIt:nrowpos,1], SDS->DS_TIPO) })    } ,055,012,,,,.T.  )

// Ŀ
// | Botao: "Desfazer amarracao do produto" ; Permite ao usuario refazer a amarracao Prod. X Prod. Fornec.    |
// | Caso usuario escolha "SIM" na pergunta de confirmacao, sao executados os 4 passoas descritos abaixo      |
// 
olBDsfz  := TButton():New(nlTl1+132,nlTl2+065,"Desfazer amarracao do produto",_opSPeDlg, {|| Iif(Aviso("Deseja desfazer a amarrao Prod x Prod.Fornec.?",("Ao clicar em <SIM> "+CRLF+"a selecodo pedido ser excluda"),{"Sim","No"})==1   											,;  // Condicao
( ( DelSDV((clCodFor+clLoja+clNota+clSerie),alItens[_opBoxIt:nrowpos,2])  						) 	,;  // -----------| - Deleta registros tabela amarracao pedido de compra - SDV
( GPrdxPrdF(clCodFor,clLoja,clNota,clSerie,alItens[_opBoxIt:nrowpos,3],"",SDS->DS_TIPO) 		)	,;  //    Opcao   | - Altera / Limpa campo DT_COD
( alRetRef:=RPrdxPrdF(clCodFor,clLoja,clNota,clSerie,alItens[_opBoxIt:nrowpos,3],,SDS->DS_TIPO) ) 	,;  //     SIM    | - Atualiza SDT com nova amarracao do usuario
( (alItens[_opBoxIt:nrowpos,2]:=alRetRef[1]),(alItens[_opBoxIt:nrowpos,4]:=alRetRef[2]) 		)  ),;  // -----------| - Atualiza browse
(	/* Opcao caso usuario escolha NAO. Nada faz / Nao usado */  									)  )}; 	// Opcao NAO
,095,012,,,,.T.  )

DEFINE SBUTTON FROM nlTl1+134,nlTl2+212 TYPE 1 ACTION(_opSPeDlg:End()) ENABLE Of _opSPeDlg
_opSPeDlg:Activate(,,,.T.,,,)

SDT->(dbCloseArea())
SB1->(dbCloseArea())
&(alNome[1,1])->(dbCloseArea())
Return Nil



/*

Descriao | Deleta os registros na tabela de relao de pedidos quando o     
          | amarracao do produto e' desfeita                                 
Ĵ
Parametros clChave  = Forn.+Loja+Nota+Serie.                                
           clProd   = Codigo do produto                                     
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       SelePed                                                          
ٱ

*/
Static Function DelSDV(clChave,clProd)

Local alArea := GetArea()

dbSelectArea("SDV")
SDV->(dbSetOrder(1))
SDV->(dbGoTop())
If SDV->(dbSeek(xFilial("SDV")+clChave))
	While SDV->(!EOF()) .AND. (clChave==(SDV->DV_FORNEC+SDV->DV_LOJA+SDV->DV_DOC+SDV->DV_SERIE))
		If (clProd==SDV->DV_PROD)
			If  RecLock("SDV",.F.)
				SDV->(DbDelete())
				MsUnlock("SDV")
			EndIf
		EndIf
		SDV->(dbSkip())
	EndDo
EndIf
SDV->(dbCloseArea())

RestArea(alArea)

Return Nil



/*

Descriao | Refaz a amarracao de produto X prod. fornecedor                  
Ĵ
Parametros clCodFor  = Cod. Fornec./Cli.                                    
          | clLoja    = Loja                                                 
          | clNota    = Num. Nota                                            
          | clSerie   = Serie da Nota                                        
          | clProdFor = cod. produto identificacao do fornecedor / cliente   
          | clPar     = NIL                                                  
          | cTipo     = Tipo da nota - Entrada ou devolucao                  
Ĵ
Retorno    alRet  = [1] - Cod. produto  / [2] - Descricao do produto        
Ĵ
 Uso       SelePed                                                          
ٱ

*/
Static Function RPrdxPrdF(clCodFor,clLoja,clNota,clSerie,clProdFor,clPar,cTipo)

Local llRetCons := .F.
Local alRet     := {"",""}
Local alArea    := GetArea()

If (llRetCons:=ConPad1(,,,"SB1",,,.F.)) // Consulta Padrao
	alRet[1] := SB1->B1_COD
	alRet[2] := SB1->B1_DESC
	GPrdxPrdF(clCodFor,clLoja,clNota,clSerie,clProdFor,SB1->B1_COD,cTipo)
Else
	alRet[2] := Posicione("SDT",2,(xFilial("SDT")+clCodFor+clLoja+clNota+clSerie+clProdFor),"DT_DESCFOR")
EndIf

RestArea(alArea)

Return alRet

/*

Descriao | Funcao procura possiveis pedidos de compra relacionados a NF     
Ĵ
Parametros clCodFor  = Cod. Fornec./Cli.                                    
          | clLoja    = Loja                                                 
          | clNota    = Num. Nota                                            
          | clSerie   = Serie da Nota                                        
          | alItens   = array contendo os itens da nota fiscal               
          | clItem    = Item selecionado                                     
          | cTipo     = Tipo da nota - Entrada ou devolucao                  
Ĵ
Retorno    alItens  = array com os itens atualizados                        
Ĵ
 Uso       SelePed	                                                        
ٱ

*/
Static Function ProcPCxNFe(clCodFor,clLoja,clNota,clSerie,alItens,clItem,cTipo)

Local nlPos   	:= Ascan(alItens,{|x|X[1]==clItem})
Local alItem1 	:= {}
Local llretCons := .F.
Local nlVarVal  := 0.01 // Variacao de valores para busca do pedido
Local clArqSQL  := GetNextAlias()
Local clQuery 	:= ""
Local cCodProdEmp := ""
Local lEmpGrupo  := .F. // Empresa do Grupo .T. = Sim / .F. = No

// Ŀ
// | VERIFICA SE O FORNECEDOR FAZ PARTE DO CADASTRO DE EMPRESAS NO SIGAMAT    |
// 
SA2->(DbSetOrder(1))
If SA2->(DbSeek(xFilial("SA2")+clCodFor+clLoja))
	If Len(PesqCGC(SA2->A2_CGC))!=0
		lEmpGrupo := .T.
	EndIf
EndIf

// Ŀ
// | CASO NAO TENHA O COD. DO PRODUTO PREENCHIDO, POSSIBILITA QUE O USUARIO   |
// | DEFINA QUAL O PRODUTO CORRESPONDENTE AO COD. PROD. DO FORNECEDOR         |
// 
dbSelectArea("SDT")
If SDT->(dbSeek(xFilial("SDT")+clCodFor+clLoja+clNota+clSerie))
	While SDT->(!EOF()) .AND. (SDT->DT_FORNEC==clCodFor)
		If AllTrim(SDT->DT_PRODFOR) == AllTrim(alItens[nlPos,3])
			If lEmpGrupo // Se for Empresa do Grupo utiliza proprio codigo XML
				cCodProdEmp := SDT->DT_PRODFOR
			Else
				cCodProdEmp := SDT->DT_COD
			EndIf
			If Empty(cCodProdEmp)
				// Ŀ
				// | PROCURA RELACIONAMENTO DO PRODUTO NA TABELA SA5/SA7|
				// 
				cCodProdEmp := PrdxForCli(clCodFor, clLoja, SDT->DT_PRODFOR, cTipo)
				If Empty(cCodProdEmp)
					If MsgYesNo("O produto da Nota est sem amarrao no sistema, cdigo "+Space(1)+AllTrim(SDT->DT_PRODFOR)+"."+CRLF+"Deseja selecionar um produto?"  )
						If (llRetCons:=ConPad1(,,,"SB1",,,.F.))
							cCodProdEmp := SB1->B1_COD
							GPrdxPrdF(clCodFor, clLoja, clNota, clSerie, SDT->DT_PRODFOR, cCodProdEmp, cTipo)
							
							_opBoxIt:aArray[_opBoxIt:nrowpos,2] := cCodProdEmp
							_opBoxIt:aArray[_opBoxIt:nrowpos,4] := SB1->B1_DESC
						EndIf
					EndIf
				Else
					GPrdxPrdF(clCodFor, clLoja, clNota, clSerie, SDT->DT_PRODFOR, cCodProdEmp, cTipo)
					
					_opBoxIt:aArray[_opBoxIt:nrowpos,2] := cCodProdEmp
					_opBoxIt:aArray[_opBoxIt:nrowpos,4] := SB1->B1_DESC
				EndIf
			EndIf
			
			// Ŀ
			// | CARREGA ARRAY QUE CONTERA AS INFORMACOES PARA A QUERY |
			// 
			aAdd(alItem1,SDT->DT_COD)       // COD. PRODUTO
			aAdd(alItem1,SDT->DT_PRODFOR)   // COD. PROD. FORNECEDOR
			aAdd(alItem1,SDT->DT_QUANT)     // QUANT. ITEM NA NF
			aAdd(alItem1,SDT->DT_VUNIT)     // VALOR UNITARIO
			Exit
		EndIf
		SDT->(dbSkip())
	EndDo
EndIf

If !Empty(cCodProdEmp)
	#IFDEF TOP
		
		// Ŀ
		// |  MONTA QUERY   |
		// 
		// Where / Condicao
		clWhere:=""
		clWhere+=" WHERE C7_FILIAL = '" + xFilial("SC7") + "' "
		If ( TcSrvType()=="AS/400" )
			clWhere+=" AND SC7.@DELETED@  <> '*'
		Else
			clWhere+=" AND SC7.D_E_L_E_T_ <> '*'
		EndIf
		clWhere+=" AND C7_FORNECE = '" + clCodFor + "' "
		clWhere+=" AND C7_LOJA = '" + clLoja + "' "
		//		clWhere+=" AND C7_PRECO BETWEEN '" + AllTrim(Str(alItem1[4]-nlVarVal)) + "' AND '" + AllTrim(Str(alItem1[4]+nlVarVal)) + "' "
		clWhere+=" AND C7_PRODUTO = '" + alItem1[1] + "' "
		clWhere+=" AND C7_QTDACLA < C7_QUANT "
		clWhere+=" AND C7_ENCER = ' '  "
		clWhere+=" AND C7_QUJE < C7_QUANT "
		
		// Query
		clQuery:=""
		clQuery+=" SELECT "
		clQuery+=" ( "
		clQuery+="	 SELECT COUNT(*) "
		clQuery+="	 FROM " + RetSqlName("SC7") + " SC7 "
		clQuery+=clWhere
		clQuery+=" ) "
		clQuery+=" AS CONT "
		clQuery+="  , C7_NUM "
		clQuery+=" 	, C7_ITEM "
		clQuery+=" 	, C7_QUANT "
		clQuery+=" 	, C7_PRECO "
		clQuery+=" 	, C7_TOTAL "
		clQuery+=" 	, C7_QTDACLA "
		clQuery+=" 	, C7_EMISSAO "
		clQuery+=" FROM " + RetSqlName("SC7") + " SC7 "
		clQuery+=clWhere
		dbUseArea(.T., "TOPCONN", TCGenQry(,,clQuery),clArqSQL, .T., .T.)
		
		dbSelectArea(clArqSQL)
		&(clArqSQL)->(dbGoTop())
		
		// Ŀ
		// |  VERIFICA SE ECONTROU PEDIDOS    |
		// 
		If &(clArqSQL)->(!EOF()) // -> ENCONTROU PEDIDOS
			MarkBrwPC(clArqSQL,alItem1,clCodFor,clLoja,clNota,clSerie)
		Else
			Aviso("Ateno",("Item no encontrado "+STRZero(Val(clItem),TamSX3("DT_ITEM")[1])+" na Nota "+clNota),{"Ok"})
		EndIf
		&(clArqSQL)->(dbCloseArea())
	#ENDIF
EndIf
Return alItens

/*

Descriao | Funcao responsavel por criat MsSelect/MarkBrowse para que o      
          | usuario escolha os pedidos de compra referentes aos itens na NF  
Ĵ
Parametros clArqSQL  = String com o nome da Tabela SQL                      
          | alItem1   = Dados do item da nota fiscal                         
          |          [1] - Cod. Produto                                      
          |          [2] - Cod. Produto FOrnecedor                           
          |          [3] - Quant. do item na Nf                              
          |          [4] - Valor unitario                                    
          | clCodFor  = Cod. Fornec./Cli.                                    
          | clLoja    = Loja                                                 
          | clNota    = Num. Nota                                            
          | clSerie   = Serie da Nota                                        
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       ProcPCxNFe                                                       
ٱ

*/
Static Function MarkBrwPC(clArqSQL,alItem1,clCodFor,clLoja,clNota,clSerie)
Local clQZ4         := 0
Local olFont        := TFont ():New(,,-11,.T.,.T.,5,.T.,5,.F.,.F.)
Local _alSize    	:= MsAdvSize()
Local nlTl1     	:= _alSize[1]
Local nlTl2    		:= _alSize[2]
Local nlTl3    		:= _alSize[1]+300
Local nlTl4     	:= _alSize[2]+520
Local clPed         := ""
Local clItmPC       := ""
Local alEstru       := {}
Local llInvert      := .F.
Local alCampos      := {}
Local clTabTmp      := ""
Local clTMPMark     := ""
Local clTMPQtd      := 0
Local alTamSDV      := {TAMSX3("DV_FORNEC")[1],TAMSX3("DV_LOJA")[1],TAMSX3("DV_DOC")[1],TAMSX3("DV_SERIE")[1],TAMSX3("DV_PROD")[1],TAMSX3("DV_NUMPED")[1],TAMSX3("DV_ITEMPC")[1]}
Local olSayQtd      := NIL
Local olMsSel01     := NIL
Local clMarca       := GetMark() // Essa varivel no pode ter outro conteudo
Private opDlgMPed   := NIL

// Foi necessario criar essas variaveis para que fosse possivel usar a funcao padrao do sistema A120Pedido()
Private INCLUI      := .F.
Private ALTERA      := .F.
Private nTipoPed    := 1
Private cCadastro   := "Seleo dos Pedidos de Compra"
Private l120Auto    := .F.

// Ŀ
// |  VERIFICA SE ALGUMA NOTA JA PREENCHE QUANTIDADE DESSE PRODUTO  |
// 
dbselectArea("SDV")
SDV->(dbSetOrder(1))
SDV->(dbGoTop())

// Ŀ
// |  ESTRUTURA PARA TABELA TEMPORARIA  |
// 
alEstru := {}
aadd(alEstru,{"MMARK",     "C",  LEn(clMarca),           0                     })
aadd(alEstru,{"PED ",      "C",  TamSx3("C7_NUM")[1],    0                     })
aadd(alEstru,{"ITEM",      "C",  TamSx3("C7_ITEM")[1],   0                     })
aadd(alEstru,{"DDATA",     "D",  8                   ,   0                     })
aadd(alEstru,{"QTDDISP" ,  "N",  TamSx3("C7_QUANT")[1],  TamSx3("C7_QUANT")[2] })
aadd(alEstru,{"QTDREF" ,   "N",  TamSx3("C7_QUANT")[1],  TamSx3("C7_QUANT")[2] })

// Ŀ
// |  CAMPOS PARA MSSELECT  |
// 
alCampos := {}
aAdd(alCampos,{"MMARK"    , , ""   	       ,""                      	})
aAdd(alCampos,{"PED"      , , "Pedido"      ,PesqPict("SC7","C7_NUM")  	})
aAdd(alCampos,{"ITEM"     , , "Item"      ,PesqPict("SC7","C7_ITEM")   })
aAdd(alCampos,{"DDATA"    , , "Data"      ,                            })
aAdd(alCampos,{"QTDDISP"  , , "Qtd.Disp." ,PesqPict("SC7","C7_QUANT")  })
aAdd(alCampos,{"QTDREF"   , , "Qtd.Infor" ,PesqPict("SC7","C7_QUANT")  })

// Cria e seleciona a tabela temporria
clTabTmp := CriaTrab(alEstru,.T.)
dbUseArea(.T.,,clTabTmp,"TMP",.F.,.F.)
dbSelectArea("TMP")

// Ŀ
// |  TRANSFERE OS DADOS PARA A TABELA TEMPORARIA  |
// 
dbSelectArea(clArqSql)
&(clArqSql+"->(dbGoTop())")
While &(clArqSql+"->(!EOF())")
	clPed 			:= &(clArqSql+"->C7_NUM")
	clItmPc 		:= &(clArqSql+"->C7_ITEM")
	clTMPMark       := ""
	clTMPQtd        := 0
	// Ŀ
	// |  VERIFICA REGISTRO NA TABELA SDV E TRAZ PREENCHIDA CASO ENCONTRE  |
	// 
	dbselectArea("SDV")
	SDV->(dbSetOrder(1))
	SDV->(dbGoTop())
	If SDV->(dbSeek(xFilial("SDV")+PadR(clCodFor,alTamSDV[1])+PadR(clLoja,alTamSDV[2])+PadR(clNota,alTamSDV[3])+PadR(clSerie,alTamSDV[4])+PadR(alItem1[1],alTamSDV[5])+PadR(clPed,alTamSDV[6])+PadR(clItmPc,alTamSDV[7])))
		clTMPMark     := clMarca
		clTMPQtd      := SDV->DV_QUANT
	EndIf
	
	dbselectArea("TMP")
	If RecLock("TMP",.T.)
		TMP->PED     	:= clPed
		TMP->ITEM    	:= clItmPc
		TMP->DDATA  	:= StoD(&(clArqSql+"->C7_EMISSAO"))
		TMP->QTDDISP 	:= (&(clArqSql+"->C7_QUANT") - (&(clArqSql+"->C7_QTDACLA")+ clQZ4))
		TMP->MMARK   	:= clTMPMark
		TMP->QTDREF    	:= clTMPQtd
		TMP->(MsUnLock())
	EndIf
	
	dbSelectArea(clArqSql)
	&(clArqSql)->(dbSkip())
EndDo

TMP->(dbGoTop())

DEFINE MSDIALOG opDlgMPed TITLE "Seleo dos Pedidos de Compra" From nlTl1,nlTl2 to nlTl3,nlTl4 PIXEL

// Ŀ
// |  CABECALHO DA TELA  |
// 
@(nlTl1+10),nlTl2 to (nlTl1+35),(nlTl2+237) PIXEL OF opDlgMPed
@(nlTl1+14),(nlTl2+005) Say AllTrim(alItem1[2]) + " / " + AllTrim(alItem1[1]) + " - " + Posicione("SB1",1,(xFilial("SB1")+PadR(alItem1[1],TamSX3("B1_COD")[1])),"B1_DESC")   Font olFont Pixel Of opDlgMPed
@(nlTl1+23),(nlTl2+005) Say "Item "   + AllTrim(STR(alItem1[3]))      Font olFont Pixel Of opDlgMPed

olSayQtd := tSay():New((nlTl1+23),(nlTl2+130),{|| "Qtd.Nota Fiscal " + AllTrim(STR(DigQtdeIt(0,alItem1[3],"C")[1])) },opDlgMPed,,olFont,,,,.T.,,,100,20)

// Ŀ
// |  MARKBROWSE / MSSELECT |
// 
olMsSel01 :=  MsSelect():New('TMP','MMARK',"",alCampos,@llInvert,@clMarca,{(nlTl1+40),(nlTl2),(nlTl3-175),(nlTl4-283)},,opDlgMPed)
olMsSel01:oBrowse:lColDrag    := .T.
olMsSel01:bMark := {|| (MarcaReg(clMarca,alItem1[3]), olMsSel01:oBrowse:Refresh(), opDlgMPed:Refresh(), olSayQtd:cCaption:= "Qtd. Sem Pedido de Compra" + AllTrim(STR(DigQtdeIt(0,alItem1[3],"C")[1])) )  }


// Ŀ
// |  BOTOES    |
// 
obTVisPe := TButton():New(nlTl1+132,nlTl2,"Visualizar Pedido",opDlgMPed,{|| MsgRun("Pedido "+Space(1)+TMP->PED+"Sendo Localizado","Aguarde...", {|| A120Pedido("SC7",PosSC7( TMP->PED ),2) })   } ,055,012,,,,.T.  )
DEFINE SBUTTON FROM nlTl1+134,nlTl2+178 TYPE 1 ACTION(eVal( {|| (MarkBrwOk(clCodFor,clLoja,clNota,clSerie,alItem1[1],alTamSDV) , opDlgMPed:End())  } )) ENABLE Of opDlgMPed
DEFINE SBUTTON FROM nlTl1+134,nlTl2+212 TYPE 2 ACTION(opDlgMPed:End()) ENABLE Of opDlgMPed

ACTIVATE DIALOG opDlgMPed CENTERED

// Ŀ
// | FECHA E DELETA ARQ. TAB. TEMP.     |
// 
TMP->(dbCloseArea())
If File( AllTrim(clTabTmp)+GetDBExtension())
	Ferase(AllTrim(clTabTmp)+GetDBExtension())
EndIf
Return Nil


/*

Descriao | Executada no botao "OK" do MarkBrowse de selecao de ped. Comp.   
          | deleta e/ou grava os registros na tabelza PED. COMP. X NFE (SDV) 
Ĵ
Parametros clCodFor   = Cod. Fornec./Cli.                                   
          | clLoja     = Loja                                                
          | clNota     = Num. Nota                                           
          | clSerie    = Serie da Nota                                       
          | clCodProd  = Codigo do produto                                   
          | alTamSDV   = Array com os tamanhos dos campos usados no dbSeek   
          |              [1] - Tam. Campo DV_FORNEC                          
          |              [2] - Tam. Campo DV_LOJA                            
          |              [3] - Tam. Campo DV_DOC                             
          |              [4] - Tam. Campo DV_SERIE                           
          |              [5] - Tam. Campo DV_PROD                            
          |              [6] - Tam. Campo DV_NUMPED                          
          |              [7] - Tam. Campo DV_ITEMPC                          
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       MarkBrwPC	                                                    
ٱ

*/
Static Function MarkBrwOk(clCodFor,clLoja,clNota,clSerie,clCodProd,alTamSDV)

Local clNumPed := ""
Local clItemPc := ""

dbSelectArea("SDV")
SDV->(dbSetOrder(1))

TMP->(dbGoTop())
While TMP->(!EOF())
	
	SDV->(dbGoTop())
	clNumPed  := PadR(TMP->PED,TamSX3("C7_NUM")[1])
	clItemPC  := PadR(TMP->ITEM,TamSX3("C7_ITEM")[1])
	dbSelectArea("SDV")
	SDV->(dbSetOrder(1))
	
	// Ŀ
	// | EXCLUI O REGISTRO DA TABELA   |
	// 
	If dbSeek(xFilial("SDV")+PadR(clCodFor,alTamSDV[1])+PadR(clLoja,alTamSDV[2])+PadR(clNota,alTamSDV[3])+PadR(clSerie,alTamSDV[4])+PadR(clCodProd,alTamSDV[5])+PadR(clNumPed,alTamSDV[6])+PadR(clItemPC,alTamSDV[7]))
		If RecLock("SDV",.F.)
			SDV->(DbDelete())
			SDV->(MsUnlock())
		EndIf
	EndIf
	
	// Ŀ
	// | GRAVA NA SDV SE ESTIVER MARCADO  |
	// 
	If !Empty(TMP->MMARK)
		Begin Transaction
		If RecLock("SDV",.T.)
			SDV->DV_FILIAL     	:= xFilial("SDV")
			SDV->DV_DOC        	:= clNota
			SDV->DV_SERIE      	:= clSerie
			SDV->DV_FORNEC      := clCodFor
			SDV->DV_LOJA   	    := clLoja
			SDV->DV_PROD  	    := clCodProd
			SDV->DV_NUMPED     	:= TMP->PED
			SDV->DV_ITEMPC		:= TMP->ITEM
			SDV->DV_QUANT		:= TMP->QTDREF
			dbCommit()
			SDV->(MsUnlock())
		EndIf
		End Transaction
	EndIf
	dbSelectArea("TMP")
	TMP->(dbSkip())
EndDo

SDV->(dbCloseArea())

Return NIL


/*

Descriao | Executada quando o registro e marcado                            
Ĵ
Parametros clMarca   = String retornada do GETMark()                        
          | nlQtdTot  = Qtd. total / maxima permitida                        
Ĵ
Retorno    NIL                                                              
Ĵ
 Uso       MarkBrwPC                                                        
ٱ

*/
Static Function MarcaReg(clMarca,nlQtdTot)

// Ŀ
// | PREENCHE COM VALOR DIGITADO PELO USUARIO  |
// 
If RecLock("TMP",.F.)
	REPLACE TMP->QTDREF with DigValIt(TMP->QTDREF,TMP->QTDDISP,nlQtdTot)
	MsUnLock()
EndIf

// Ŀ
// | VERIFICA SE O VALOR E ZERO. SE SIM DESMARCA REGISTRO  |
// 
If Empty(TMP->QTDREF)
	If RecLock("TMP",.F.)
		REPLACE TMP->MMARK with ""
		MsUnLock()
	EndIF
Else
	If RecLock("TMP",.F.)
		REPLACE TMP->MMARK with clMarca
		MsUnLock()
	EndIF
EndIf

Return Nil

/*

Descriao | Funcao cria telinha para que o usuario digite numa get o valor   
          | (unidades) do item da nota fiscal correspondente ao pedido selec.
Ĵ
Parametros nlValGet   = quantidade ja preenchido                            
          | nlValDisp  = quantidade maxima disponivel                        
          | nlQtdTot   = quantidade total                                    
Ĵ
Retorno    Se variavel llOk == .T., retorna valor digitado 'nlValGet'       
          | senao retorna  nlValAnt = valor anterior                         
Ĵ
 Uso       MarcaReg		                                                    
ٱ

*/
Static Function DigValIt(nlValGet,nlValDisp,nlQtdTot)

Local nlValAnt  	:= nlValGet
Local _alSize   		:= MsAdvSize()
Local llOk     		:= .F.
Local olGetVal  	:= Nil
Private _opdlgGet 	:= Nil

DEFINE MSDIALOG _opdlgGet TITLE "Quantidade" From _alSize[1],_alSize[2] to (_alSize[1]+080),(_alSize[2]+195) PIXEL

olGetVal :=TGet():New((_alSize[1]+10),(_alSize[2]+15),{|u| if(PCount()>0,nlValGet:=u,nlValGet)}, _opdlgGet ,50,10,PesqPict("SC7","C7_QUANT") , {|| ValorNFxPC(nlValGet, nlValDisp, nlQtdTot ) },,,,,,.T.,,,,,,,.F.,,,"nlValGet")
DEFINE SBUTTON FROM (_alSize[1]+28),(_alSize[2]+57) TYPE 1 ACTION(eVal( {|| ( (llOk:=.T.),_opdlgGet:End())  } )) ENABLE Of _opdlgGet

ACTIVATE DIALOG _opdlgGet CENTERED

Return ( Iif(llOk,nlValGet,nlValAnt) )

/*

Descriao | Valida o valor informado do item da nota fiscal correspondente     
          | ao pedido selecionado. 											  
Ĵ
Parametros nlValGet   = quantidade ja preenchido                              
          | nlValDisp  = quantidade maxima disponivel                          
          | nlQtdTot   = quantidade total                                      
Ĵ
Retorno    Lgico	 														  
Ĵ
 Uso       DigValIt		                                                      
ٱ

*/
Static Function ValorNFxPC(nlValGet, nlValDisp, nlQtdTot )
Local lRet := .F.

If (nlValGet<=nlValDisp) .AND. (DigQtdeIt(nlValGet,nlQtdTot,"V")[2] ) .And. Positivo(nlValGet)
	lRet := .T.
Else
	Aviso("Ateno","O valor informado do Itema da nota" + CHR(13)+CHR(10) + "no corresponde ao pedido selecionado" ,{"Ok"})
	lRet := .F.
EndIf

Return lRet
/*

Descriao | Funcao cria telinha para que o usuario digite numa get o valor   
          | (unidades) do item da nota fiscal correspondente ao pedido selec.
Ĵ
Parametros nlValGet   = quantidade ja preenchido                            
          | nlQtdTot   = quantidade total                                    
          | clFin      = Finalidade da funcao. Podendo receber "C" ou "V"    
          | Se recebe "V" (verificar), valida se ainda  possivel selecionar 
          | valores referente ao item da nota. Valida o maximo.              
          | Se "C" apenas calcula a quant. ja informada ( alRet[1] )         
Ĵ
Retorno    alRet = array 2 posicoes                                         
          |         [1] - soma dos valores jah preenchidos para o iten       
          |         [2] - booleana - Se .F., nao possivel mais indicar valor 
Ĵ
 Uso       MarkBrwPC, ValorNFxPC                                            
ٱ

*/
Static Function DigQtdeIt(nlValGet,nlQtdTot,clFin)

Local alRet 	:= {0,.T.}
Local nlReg 	:= TMP->(Recno())

TMP->(dbGoTop())
While  TMP->(!EOF())
	If (clFin=="V")
		If (TMP->(Recno()) <> nlReg)
			alRet[1]+=TMP->QTDREF
		EndIf
	Else
		alRet[1]+=TMP->QTDREF
	EndIf
	TMP->(dbSkip())
EndDo
TMP->(dbGoTop())

TMP->(dbGoTo(nlReg))
If (clFin=="V")
	If ((alRet[1]+nlValGet) > nlQtdTot)
		alRet[2] := !alRet[2]
	EndIf
Else
	alRet[1] := (nlQtdTot-alRet[1])
EndIf
Return alRet

/*

Descriao | Funcao para posicionar a Tabela SC7 no pedido escolhido          
          | retorna o recno que sera passado como parametro na funcao padrao 
          | do sistema A120Pedido()                                          
Ĵ
Parametros clPed = Numero do pedido de compra                               
Ĵ
Retorno    nlRet = SC7->(Recno())                                           
Ĵ
 Uso       MarkBrwPC	                                                    
ٱ

*/
Static Function PosSC7(clPed)

Local nlRet := 0

dbSelectArea("SC7")
dbSetOrder(1)
SC7->(dbGoTop())
If dbSeek(xFilial("SC7")+PadR(clPed,TamSx3("C7_NUM")[1]) )
	nlRet := SC7->(Recno())
EndIf
Return nlRet


/*

Descriao | Funcao que monta aCols, aHeader para tela e executa rotina aut.  
Ĵ
Parametros nlOpc     := Opcao escolhida (2-Visu / 3-Gerar)                  
          | clCodFor  := Cod. Fornecedor/Cliente                             
          | clLoja    := Loja                                                
          | clNota    := Num. Nota                                           
          | clSerie   := Serie                                               
          | olLBox1    := Objeto                                              
Ĵ
Retorno    Nil                                                              
Ĵ
 Uso       MontaBrw	                                                        
ٱ

*/
Static Function ExecTela(nlOpc,clCodFor,clLoja,clNota,clSerie,olLBox1)

Local nlUsado       := 0
Local alDTVirt      := {}
Local alDTVisu      := {}
Local alRecDT       := {}
Local alSF1         := {}
Local alSD1         := {}
Local _alSize        := MsAdvSize(.T.)
Local clKey         := ""
Local clAwysT       := "AllwaysTrue()"
Local alCpoEnch     := {}
Local alHeaderDT    := {}
Local llPedCom      := .F.
Local llD1Imp       := .F.

Private clTab1	    := "SDS"
Private clTab2	    := "SDT"

Private lMsErroAuto := .F.
Private aCols 	    := {}
Private aHeader     := GdMontaHeader(	@nlUsado     	 ,; //01 -> Por Referencia contera o numero de campos em Uso
@alDTVirt                ,; //02 -> Por Referencia contera os Campos do Cabecalho da GetDados que sao Virtuais
@alDTVisu                ,; //03 -> Por Referencia contera os Campos do Cabecalho da GetDados que sao Visuais
clTab2                   ,; //04 -> Opcional, Alias do Arquivo Para Montagem do aHeader
{"DT_FILIAL"} 			 ,; //05 -> Opcional, Campos que nao Deverao constar no aHeader
.F.                      ,; //06 -> Opcional, Carregar Todos os Campos
.F.                      ,; //07 -> Nao Carrega os Campos Virtuais
.F.                      ,; //08 -> Carregar Coluna Fantasma e/ou BitMap ( Logico ou Array )
NIL                      ,; //09 -> Inverte a Condicao de aNotFields carregando apenas os campos ai definidos
.T.                      ,; //10 -> Verifica se Deve Checar se o campo eh usado
.T.                      ,;
.F.                      ,;
.F.                      ,;
)

//Ŀ
// POSICIONA A TABELA SDS / CARREGA VARIAVEIS DE MEMORIA   
//
dbSelectArea(clTab1)
dbSetOrder(1)
&(clTab1+"->(dbGoTop())")

dbSeek(xFilial(clTab1)+clNota+clSerie+clCodFor+clLoja)
RegToMemory("SDS",.F.)


//Ŀ
// CAMPOS USADOS PARA ENCHOICE   
//
dbSelectArea("SX3")
SX3->(dbSetOrder(1))
SX3->(dbGoTop())
SX3->(dbSeek("SDS"))
alCpoEnch:={}
Do While !Eof().And.(SX3->X3_ARQUIVO=="SDS")
	V_CPO:=ALLTRIM(X3_CAMPO)
	If X3USO(SX3->X3_USADO).And.cNivel>=SX3->X3_NIVEL
		Aadd(alCpoEnch,V_CPO)
	Endif
	DbSkip()
End Do

//Ŀ
// MONTA ACOLS   
//
dbSelectArea("SDT")
SDT->(dbSetOrder(1))
SDT->(dbGoTop())
alRecDT := {}
alHeaderDT:=aClone(aHeader)
clKey := xFilial("SDS")+M->DS_CNPJ+clCodFor+clLoja+clNota+clSerie
aCols := GdMontaCols(	@alHeaderDT		,; 	//01 -> Array com os Campos do Cabecalho da GetDados
@nlUsado		,;	//02 -> Numero de Campos em Uso
@alDTVirt		,;	//03 -> [@]Array com os Campos Virtuais
@alDTVisu   	,;	//04 -> [@]Array com os Campos Visuais
clTab2			,;	//05 -> Opcional, Alias do Arquivo Carga dos Itens do aCols
NIL				,;	//06 -> Opcional, Campos que nao Deverao constar no aHeader
@alRecDT		,;	//07 -> [@]Array unidimensional contendo os Recnos
clTab1			,;	//08 -> Alias do Arquivo Pai
clKey  			,;	//09 -> Chave para o Posicionamento no Alias Filho
NIL				,;	//10 -> Bloco para condicao de Loop While
NIL				,;	//11 -> Bloco para Skip no Loop While
.F.				,;	//12 -> Se Havera o Elemento de Delecao no aCols
.F.				,;	//13 -> Se cria variaveis Publicas
.T.				,;	//14 -> Se Sera considerado o Inicializador Padrao
NIL				,;	//15 -> Lado para o inicializador padrao
NIL				,;	//16 -> Opcional, Carregar Todos os Campos
.F.				,;	//17 -> Opcional, Nao Carregar os Campos Virtuais
NIL				,;	//18 -> Opcional, Utilizacao de Query para Selecao de Dados
NIL				,;	//19 -> Opcional, Se deve Executar bKey  ( Apenas Quando TOP )
NIL				,;	//20 -> Opcional, Se deve Executar bSkip ( Apenas Quando TOP )
.F.				,;	//21 -> Carregar Coluna Fantasma
NIL				,;	//22 -> Inverte a Condicao de aNotFields carregando apenas os campos ai definidos
.T.				,;	//23 -> Verifica se Deve Checar se o campo eh usado
.T.				,;	//24 -> Verifica se Deve Checar o nivel do usuario
NIL				,;	//25 -> Verifica se Deve Carregar o Elemento Vazio no aCols
NIL				,;	//26 -> [@]Array que contera as chaves conforme recnos
NIL				,;	//27 -> [@]Se devera efetuar o Lock dos Registros
NIL				,;	//28 -> [@]Se devera obter a Exclusividade nas chaves dos registros
NIL				,;	//29 -> Numero maximo de Locks a ser efetuado
.F.				,;	//30 -> Utiliza Numeracao na GhostCol
NIL				,;	//31
2		    	 ;	//32 -> nOpc
)

//Ŀ
// MONTA TELA MODELO 3   
//
If Mod3XML(	nlOpc,;                  								  		// 01 -> Opcao
	"Nf-e Disponveis",;                  								  		// 02 -> Titulo da Tela
	clTab1,;                  								  		// 03 -> Tabela para Enchoice
	clTab2,;               									 		// 04 -> Tabela para GetDados
	alCpoEnch,;                 							  		// 05 -> Campos Enchoice
	clAwysT,;                 								  		// 06 -> CampoOk
	clAwysT,;                  								 		// 07 -> LinhaOk
	nlOpc,;                 										// 08 -> Opcao Enchoice
	nlOpc,;                  										// 09 -> Opcao GetDados
	clAwysT,;                  										// 10 -> TdOk
	.T.,;                  											// 11 -> Se carrega Campos Virtuais
	alCpoEnch,;                  									// 12 -> Campos alterar
	GetRodape(clCodFor,clLoja,clNota,clSerie,clTab1) )  ;   		// 13 -> Array com as informacoes do Radape
	.AND. VldCpoProd(clCodFor,clLoja,clNota,clSerie,SDS->DS_TIPO)
	
	//Ŀ
	// GERA A PRE-NOTA   
	//
	Begin Transaction
	//Ŀ
	// ALIMENTA VETORES PARA A ROTINA AUTOMATICA (MSExecAuto)   
	//
	alSF1:=F1Imp(clCodFor,clLoja,clNota,clSerie,clTab1)
	MsgRun("Aguarde...",,{|| iif(!Empty(alSD1:=D1Imp(clCodFor,clLoja,clNota,clSerie,clTab2)),llD1Imp:=.T.,llD1Imp:=.F.  ) } )
	MsgRun("Aguarde...",,{|| llPedCom := VldQtdPC(alSD1) } )
	If llD1Imp .AND. llPedCom
		lMsErroAuto := .F.
		MsgRun("Aguarde gerando Pr-Nota de Entrada...",,{|| MSExecAuto({|x,y,z| MATA140(x,y,z)},alSF1,alSD1,3 )})
		
		If !lMsErroAuto
			//Ŀ
			// APOS EXECUTADA A ROTINA AUTOMATICA                 
			// ATUALIZA REGISTRO ( STATUS, DATA IMPORTACAO ...)   
			//
			dbSelectArea(clTab1)
			dbSetOrder(1)
			&(clTab1)->(dbGoTop())
			If dbSeek(xFilial(clTab1)+clNota+clSerie+clCodFor+clLoja)
				If RecLock(clTab1,.F.)
					Replace DS_USERPRE  With cUserName
					Replace DS_DATAPRE  With dDataBase
					Replace DS_HORAPRE  With Time()
					Replace DS_STATUS   With 'P' // P = PROCESSADA PELO PROTHEUS
					&(clTab1)->(MsUnLock())
					Aviso("Ateno", "Pr-Nota gerada com Sucesso!" ,{"Ok"})
				EndIf
			EndIf
		Else
			DisarmTransaction()
			lMsErroAuto := .F.
			MostraErro()
		EndIf
	EndIf
	End Transaction
EndIf
Return Nil

/*

Descriao | Essa funcao executada quando gera pre nota. Se retornar True     
          | gera a rotina automatica.                                        
          | Funcao verifica se a quant. do pedido de compra escolhido condiz 
          | com a quant. disponivel do pedido de compra (SC7) atualizado     
Ĵ
Parametros alItns := Array com os itens (D1) para rotina automatica         
Ĵ
Retorno    llRet = Se .T. = OK                                              
Ĵ
 Uso       ExecTela                                                         
ٱ

*/
Static Function VldQtdPC(alItns)

Local llRet     := .T.
Local nlK       := 0
Local llErro    := .F.
Local nlPedPos  := 0
Local nlItnPos  := 0
Local nlQtdPos  := 0
Local nlForPos  := 0
Local nlLojPos  := 0
Local nlNotPos  := 0
Local nlSerPos  := 0
Local nlCodPos  := 0

//Ŀ
// LACO PERCORRE O ARRAY DOS ITENS E FAZ VERIFICACAO SE O ITEM TIVER PED. DE COMPRA PREENCHIDO  
//
For nlK:=1 to Len(alItns)
	If ((nlPedPos:=Ascan(alItns[nlK],{|x|X[1]=="D1_PEDIDO"}))>0) .AND. ((nlItnPos:=Ascan(alItns[nlK],{|x|X[1]=="D1_ITEMPC"}))>0)
		//Ŀ
		// VERIFICA AS POSICOES DOS CAMPOS NO ARRAY  
		//
		nlQtdPos := Ascan(alItns[nlK],{|x|X[1]=="D1_QUANT"})
		nlForPos := Ascan(alItns[nlK],{|x|X[1]=="D1_FORNECE"})
		nlLojPos := Ascan(alItns[nlK],{|x|X[1]=="D1_LOJA"})
		nlNotPos := Ascan(alItns[nlK],{|x|X[1]=="D1_DOC"})
		nlSerPos := Ascan(alItns[nlK],{|x|X[1]=="D1_SERIE"})
		nlCodPos := Ascan(alItns[nlK],{|x|X[1]=="D1_COD"})
		//Ŀ
		// VERIFICA SE NA TABELA DE PED. DE COMPRAS EXISTE REALMENTE A QUANT. DISPONIVEL 
		// SE FOR TIVER DIFERENCA PARA MAIS, EXCLUI DA SDV                               
		//
		dbSelectArea("SC7")
		dbSetOrder(1)
		SC7->(dbGoTop())
		If SC7->(dbSeek(xFilial("SC7")+PadR(alItns[nlK,nlPedPos,2],TamSx3("C7_NUM")[1])+ PadR(alItns[nlK,nlItnPos,2],TamSx3("C7_ITEM")[1])))
			If (alItns[nlK,nlQtdPos,2] > (SC7->C7_QUANT-SC7->C7_QTDACLA) )
				dbSelectArea("SDV")
				dbSetOrder(1)
				SDV->(dbGoTop()) // dbSeek - > Fornecedor+Loja+Nota Num.+Serie+Cod. Produto+Num. Pedido+Item PC
				If SDV->(dbSeek(xFilial("SDV")+alItns[nlK,nlForPos,2]+alItns[nlK,nlLojPos,2]+alItns[nlK,nlNotPos,2]+alItns[nlK,nlSerPos,2]+alItns[nlK,nlCodPos,2]+alItns[nlK,nlPedPos,2]+alItns[nlK,nlItnPos,2] ))
					If RecLock("SDV",.F.)
						SDV->(DbDelete())
						SDV->(MsUnlock())
					EndIf
					llErro:=.T.
				EndIf
			EndIf
		EndIf
	EndIf
Next nlK
//Ŀ
// EXIBE MENSAGEM DE ERRO  
//
If llErro
	Aviso("Ateno","Erro ao importar a Pr-Nota",{"Ok"})
	llRet:=.F.
EndIf

Return llRet


/*

Descriao | Verifica se o campo Produto esta preenchido. Caso nao esteja exec
          | funcao para que o usuario escolha qual produto se corresponde    
Ĵ
Parametros clCodFor  := Cod. Fornecedor/Cliente                             
          | clLoja    := Loja                                                
          | clNota    := Num. Nota                                           
          | clSerie   := Serie                                               
          | clTipo    := N = Nota fiscal Normal / B ou D = Benef./Devolucao  
Ĵ
Retorno    llRet = Se .T. = OK                                              
Ĵ
 Uso       ExecTela                                                         
ٱ

*/
Static Function VldCpoProd(clCodFor,clLoja,clNota,clSerie, clTipo)

Local llRet     := .T.
Local nlK       := 0
Local nlPosCmp  := Ascan(aHeader,{|x|Alltrim(X[2])=="DT_COD"})

For nlK:=1 to Len(aCols)
	If Empty(aCols[nlK,nlPosCmp])
		llRet:=EscolhaPrd(clCodFor,clLoja,clNota,clSerie,clTipo,nlK,nlPosCmp)
		Exit
	EndIf
Next nlK

Return llRet


/*

Descriao | Monta a tela com os produtos sem cod. para que usuario escolha   
Ĵ
Parametros clCodFor  := Cod. Fornecedor/Cliente                             
          | clLoja    := Loja                                                
          | clNota    := Num. Nota                                           
          | clSerie   := Serie                                               
          | clTipo    := N = Nota fiscal Normal / B ou D = Benef./Devolucao  
          | nlK       := Primeira posicao do acols encontrada sem Cod. Prod. 
          | nlPosCmp  := Posicao no aHeader do campo "DT_COD"                
Ĵ
Retorno    llProcPrd = Se .T. = OK                                          
Ĵ
 Uso       VldCpoProd                                                       
ٱ

*/
Static Function EscolhaPrd(clCodFor,clLoja,clNota,clSerie, clTipo, nlK, nlPosCmp)

Local llProcPrd     :=.F.
Local _alSize    	:= MsAdvSize()
Local nlTl1     	:= _alSize[1]
Local nlTl2    		:= _alSize[2]
Local nlTl3    		:= _alSize[1]+300
Local nlTl4     	:= _alSize[2]+520
Local olFont        := TFont ():New(,,-11,.T.,.T.,5,.T.,5,.F.,.F.)
Local llRetCons     := .F.
Local alHeaderTw    := {("Escolha produto"+Iif(AllTrim(clTipo)=="N","Fornecdor","Cliente" )),"Produto","Descrio"}
Local alTamHeader   := {60,60,100}
Local alRegs        := {}
Local olLisBox      := NIL
Local olBtInf       := NIL
Local alAlias       := Iif(AllTrim(clTipo)=="N",{"SA2","A2_NOME"},{"SA1","A1_NOME"})
Local nlCodPos      := Ascan(aHeader,{|x|Alltrim(X[2])=="DT_PRODFOR"})
Local nlCont        := 0
Private _opPPrDlg  	:= NIL

// Ŀ
// | SELECIONA REGISTROS  |
// 
For nlCont:=nlK to Len(aCols)
	If Empty(aCols[nlCont,nlPosCmp])
		aAdd(alRegs,{(aCols[nlCont,nlCodPos]),"","",nlCont})
	EndIf
Next nlCont

// Ŀ
// | TELA - INTERFACE   |
// 

DEFINE MSDIALOG _opPPrDlg TITLE "Seleo Produtos" From nlTl1,nlTl2 to nlTl3,nlTl4 PIXEL

// Box
@(nlTl1+10),nlTl2 to (nlTl1+35),(nlTl2+237) PIXEL OF _opPPrDlg
@(nlTl1+14),(nlTl2+005) Say "Fornecedor: " + clCodFor + " - " + Posicione(alAlias[1],1,(xFilial(alAlias[1])+clCodFor+clLoja),alAlias[2])   Font olFont Pixel Of _opPPrDlg
@(nlTl1+23),(nlTl2+005) Say "Itens sem Cdigo Inforshop" Font olFont Pixel Of _opPPrDlg

// Ŀ
// | TW BROWSE - ITENS DA NOTA |
// 	     //larg       //alt
olLisBox := TwBrowse():New(nlTl1+40,nlTl2,nlTl4-295,nlTl3-217,,alHeaderTw,alTamHeader,_opPPrDlg,,,,,,,,,,,,.F.,,.T.,,.F.,,,)
olLisBox:SetArray(alRegs)
olLisBox:bLine := {|| {alRegs[olLisBox:nAt,1],alRegs[olLisBox:nAt,2],alRegs[olLisBox:nAt,3]} }

// Ŀ
// |  BOTOES    |
// 
olBtInf  := TButton():New(nlTl1+132,nlTl2,"Produto" ,_opPPrDlg,{|| (llRetCons:=ConPad1(,,,"SB1",,,.F.)),(Iif(llRetCons, ((alRegs[olLisBox:nAt,2]:=SB1->B1_COD),(alRegs[olLisBox:nAt,3]:=SB1->B1_DESC)) ,  ) )    } ,065,012,,,,.T.  )
DEFINE SBUTTON FROM nlTl1+134,nlTl2+178 TYPE 1 ACTION (eVal( {|| llProcPrd:=PrcPrdOK(alRegs),  Iif((llProcPrd==.T.),(AtuSDT(alRegs,nlPosCmp,clCodFor,clLoja,clNota,clSerie, clTipo),_opPPrDlg:End()),Aviso("Ateno" ,"Produto no encontrado" ,{"Ok" }))   } )) ENABLE Of _opPPrDlg
DEFINE SBUTTON FROM nlTl1+134,nlTl2+212 TYPE 2 ACTION (eVal( {|| Iif(MsgyESnO("Deseja sair?"),_opPPrDlg:End(),) } )) ENABLE Of _opPPrDlg

ACTIVATE DIALOG _opPPrDlg CENTERED

Return llProcPrd


/*

Descriao | Funcao atualiza aCols e tabela SDT pela escolha do usuario       
Ĵ
Parametros alRegs    := Array com os registros                              
          | nlPosCmp  := Posicao no aHeader do Campo DT_COD                  
          | clCodFor  := Cod. Fornecedor/Cliente                             
          | clLoja    := Loja                                                
          | clNota    := Num. Nota                                           
          | clSerie   := Serie                                               
Ĵ
Retorno    Nil                                                              
Ĵ
 Uso       EscolhaPrd                                                       
ٱ

*/
Static Function AtuSDT(alRegs,nlPosCmp,clCodForCli,clLoja,clNota,clSerie, clTipo)

Local nlK         := 0
Local nlPosDes 	  := Ascan(aHeader,{|x|Alltrim(X[2])=="DT_DESC"})
Local cProdForCli := ""
Local aArea		  := GetArea()

For nlK:=1 to Len(alRegs)
	// Ŀ
	// | ATUALIZA ACOLS     |
	// 
	aCols[alRegs[nlK,Len(alRegs[nlK])],nlPosCmp] := alRegs[nlK,2]
	aCols[alRegs[nlK,Len(alRegs[nlK])],nlPosDes] := alRegs[nlK,3]
	
	cProdForCli := PadR(AllTrim(alRegs[nlK,1]),TamSx3("DT_PRODFOR")[1])
	cProdEmp	:= PadR(AllTrim(alRegs[nlK,2]),TamSX3("B1_COD")[1]		)
	
	// Ŀ
	// | ATUALIZA RELACIONAMENTO PRODUTO X FORNECEDOR E TABELA SDT|
	// 
	GPrdxPrdF(clCodForCli, clLoja, clNota, clSerie, cProdForCli, cProdEmp, clTipo)
	
Next nlK

RestArea(aArea)
Return Nil

/*

Descriao | Validacao do botao OK na tela de selecao de prod. correspondente 
Ĵ
Parametros alRegs     := Array com os itens                                 
Ĵ
Retorno    Nil                                                              
Ĵ
 Uso       EscolhaPrd                                                       
ٱ

*/
Static Function PrcPrdOK(alRegs)

Local llPrcPrdOk := .T.
Local nlT        := 0

For nlT:=1 to Len(alRegs)
	If Empty(alRegs[nlT,2])
		llPrcPrdOk := !llPrcPrdOk
		Exit
	EndIf
Next nlT
Return llPrcPrdOk


/*

Descriao | Funcao que busca as inforamcoes do rodape da tela mod. 3         
Ĵ
Parametros clCodFor  := Cod. Fornecedor/Cliente                             
          | clLoja    := Loja                                                
          | clNota    := Num. Nota                                           
          | clSerie   := Serie                                               
          | clTab1    := Tabela SDS                                          
Ĵ
Retorno    Array alNFe				                                        
Ĵ
 Uso       ExecTela	                                                        
ٱ

*/
Static Function GetRodape(clCodFor,clLoja,clNota,clSerie,clTab1)

Local alNFe 	:= {}

dbSelectArea(clTab1)
dbSetOrder(1)
&(clTab1)->(dbGoTop())
If dbSeek(xFilial(clTab1)+clNota+clSerie+clCodFor+clLoja)
	aAdd(alNFe, &(clTab1+"->DS_STATUS"  ))
	aAdd(alNFe, &(clTab1+"->DS_ARQUIVO" ))
	aAdd(alNFe, &(clTab1+"->DS_USERIMP" ))
	aAdd(alNFe, &(clTab1+"->DS_DATAIMP" ))
	aAdd(alNFe, &(clTab1+"->DS_HORAIMP" ))
EndIf


Return alNFe



/*

Descriao | Rotina principal para importar Schema XML                        
Ĵ
Parametros nlOpc       := Opcao do Uusario (2-Visualizar/3-Gerar Pre Nota)  
          | clTitle     := Titulo da Tela                                    
          | clTab1      := Alias da Enchoice                                 
          | clTab2      := Alias da GetDados                                 
          | alCpoEnch   := Cmpos da Enchoice                                 
          | clAwysT     := cLinhaOk                                          
          | clAwysT     := cTudoOk                                           
          | nlOpc1      := Opcao Enchoice                                    
          | nlOpc2      := Opcao GetDados                                    
          | clAwysT     := cFieldOk                                          
          | llVirtual   := llVirtual (Campos Virtuais)                       
          | alCpoEnch   := Campos Alteracao enchoice                         
          | alInfRod    := Array com as informacoes do radpe 			    
Ĵ
Retorno    llRet                                                            
Ĵ
 Uso       ExecTela	                                                        
ٱ

*/
Static Function Mod3XML(nlOpc,clTitle,clTab1,clTab2,alCpoEnch,clAwysT,clAwysT,nlOpc1,nlOpc2,clAwysT,llVirtual,alAltEnch,alInfRod)

Local alAdvSz    := MsAdvSize()
Local alRNfe     := alInfRod
Local olFld      := NIL
Local llRet 	 := .F.
Local olFont     := TFont ():New(,,-11,.T.,.F.,5,.T.,5,.F.,.F.)
Local olFont2    := TFont ():New(,,-11,.T.,.T.,5,.T.,5,.F.,.F.)
Local clPicture  := "@E 999,999,999.99"
Local olEnch     := NIL
Local olGetDd    := NIL
Local olGetStats := NIL
Local olGetArq   := NIL
Local olGetUser  := NIL
Local olGetData  := NIL
Local olGetHora  := NIL
Local clGStatus  := Iif( Empty(Upper(alRNfe[1])),"???","???")
Local clGNomArq  := Upper(alRNfe[2])
Local clGUser    := alRNfe[3]
Local dlGData    := alRNfe[4]
Local clGHora    := alRNfe[5]
Local nPosDesc	 := 0
Local nPosProd	 := 0
Local cDescProd	 := ""
Local nLoop
Local nLoops
Private aTrocaF3  := {}
Private _opMoD3lg := NIL
   
Private aRotina := { {"Pesquisar","AxPesqui",0,1} ,;
             {"Visualizar","AxVisual",0,2} ,;
             {"Incluir","AxInclui",0,3} ,;
             {"Alterar","AxAltera",0,4} ,;
             {"Excluir","AxDeleta",0,5} }
DEFINE MSDIALOG _opMoD3lg TITLE clTitle From alAdvSz[1],alAdvSz[2] to (alAdvSz[1]+450),(alAdvSz[2]+690) PIXEL

olFld      := TFolder():New((alAdvSz[1]+151),(alAdvSz[2]-6),{"Arquivos XML carregados"},{},_opMoD3lg,,,,.T.,.F., 334 , 068  )

// AJUSTA TELA PARA TEMA P10
If (Alltrim(GetTheme()) == "TEMAP10") .Or. SetMdiChild()
	_opMoD3lg:nHeight+=025
EndIf


// Muda Consulta padrao do cmapo DS_FORNEC para tabela de Clientes - SA1
IF AllTrim(SDS->DS_TIPO)<>"N"
	Aadd(aTrocaF3,{"DS_FORNEC", "SA1"} )
EndIf

// Ŀ
//  Monta enchoice e getDados 			  				  
// 
RegToMemory(clTab1,.F.)
olEnch := Msmget():New(clTab1,&(clTab1)->(Recno()),2,,,,alCpoEnch,{15,5,80,340},,3,,,,_opMoD3lg,,.T.,,,,,,,,.T.)

If !(Type("aHeader") == "U") .AND. !(Type("aCols") == "U") .AND. ((nPosDesc := GDFieldPos("DT_DESC", aHeader))>0) .AND. ((nPosProd := GDFieldPos("DT_COD", aHeader))>0)
	
	nLoops := Len( aCols  )
	For nLoop := 1 To nLoops
		cDescProd := Posicione("SB1",1,xFilial("SB1")+aCols[nLoop][nPosProd],"B1_DESC")
		GdFieldPut( "DT_DESC" , cDescProd , nLoop , aHeader , aCols )
	Next nLoop
	
EndIf

olGetDd := MsGetDados():New(84,5,150,340,2,clAwysT,clAwysT,"",.T.,,,,,clAwysT)

// Ŀ
//  Monta Rodape         
// 

// ---- NOTA FISCAL ELETRONICA
// Status
@(alAdvSz[1]+010),(alAdvSz[2]-2) Say "Status" Font olFont Pixel Of olFld:aDialogs[1]
olGetStats := TGet():New((alAdvSz[1]+08),(alAdvSz[2]+045),{|u| if(PCount()>0,clGStatus:=u,clGStatus)}, olFld:aDialogs[1] ,110,10,"@!",,,,,,,.T.,,,,,,,.T.,,,"clGStatus")
// Arquivo
@(alAdvSz[1]+025),(alAdvSz[2]-2) Say "Arquivo" Font olFont Pixel Of olFld:aDialogs[1]
olGetArq := TGet():New((alAdvSz[1]+23),(alAdvSz[2]+045),{|u| if(PCount()>0,clGNomArq:=u,clGNomArq)}, olFld:aDialogs[1] ,110,10,"@!",,,,,,,.T.,,,,,,,.T.,,,"clGNomArq")
// Usuario Import
@(alAdvSz[1]+010),(alAdvSz[2]+170) Say "Usuario Import" Font olFont Pixel Of olFld:aDialogs[1]
olGetUser := TGet():New((alAdvSz[1]+08),(alAdvSz[2]+240),{|u| if(PCount()>0,clGUser:=u,clGUser)}, olFld:aDialogs[1] ,70,10,,,,,,,,.T.,,,,,,,.T.,,,"clGUser")
// Data Import
@(alAdvSz[1]+025),(alAdvSz[2]+170) Say "Data Import" Font olFont Pixel Of olFld:aDialogs[1]
olGetData := TGet():New((alAdvSz[1]+23),(alAdvSz[2]+240),{|u| if(PCount()>0,dlGData:=u,dlGData)}, olFld:aDialogs[1] ,50,10,,,,,,,,.T.,,,,,,,.T.,,,"dlGData")
// Hora Import
@(alAdvSz[1]+040),(alAdvSz[2]+170) Say "Hora Import" Font olFont Pixel Of olFld:aDialogs[1]
olGetHora := TGet():New((alAdvSz[1]+38),(alAdvSz[2]+240),{|u| if(PCount()>0,clGHora:=u,clGHora)}, olFld:aDialogs[1] ,40,10,,,,,,,,.T.,,,,,,,.T.,,,"clGHora")

ACTIVATE DIALOG _opMoD3lg ON INIT(EnchoiceBar(_opMoD3lg,  {|| (Iif((nlOpc==3),llRet:=.T.,),_opMoD3lg:End()) } , {|| _opMoD3lg:End()},  ,  )) CENTERED

Return llRet

/*

Descriao | Carrega Array com os itens da nota fiscal para rotina automatica 
Ĵ
Parametros clCodFor = Cod. Fornecedor                                       
          | clLoja   = Loja                                                  
          | clNota   = Num. NOta                                             
          | clSerie  = Serie                                                 
          | clTab    = Tabela de itens - SDT                                 
Ĵ
Retorno    alRet = array com os dados para execucao da rotina automatica    
Ĵ
 Uso       ExecTela	                                                        
ٱ

*/
Static Function D1Imp(clCodFor,clLoja,clNota,clSerie,clTab)
  
Local alItens	 := {}
Local alRet      := {}
Local nlQtd      := 0
Local nlCont	 := 0
Local alBaseImp  := {}
Local alAliqImp  := {}

aDePara:={}

dbSelectArea("SX5")
dbSetOrder(1)

alBaseImp := {}
alAliqImp := {}

DbSelectArea("SD1")
dbSetorder(1)
DbSelectArea("SB1")
dbSetorder(1)

dbSelectarea(clTab)
dbSetOrder(2) //DT_FILIAL+DT_FORNEC+DT_LOJA+DT_DOC+DT_SERIE+DT_PRODFOR
dbSeek(xFilial(clTab)+clCodFor+clLoja+clNota+clSerie)

do While &(clTab)->(!eof()) .and. &(clTab)->(DT_FILIAL+DT_FORNEC+DT_LOJA+DT_DOC+DT_SERIE)=xFilial(clTab)+clCodFor+clLoja+clNota+clSerie
	
	SB1->(dbSeek(xfilial("SB1")+SDT->DT_COD))
	alItens:={}
	aAdd(alItens,{"D1_DOC"      , SDT->DT_DOC             ,NIL})
	aAdd(alItens,{"D1_SERIE"    , SDT->DT_SERIE           ,NIL})
	aAdd(alItens,{"D1_FORNECE"  , SDT->DT_FORNEC          ,NIL})
	aAdd(alItens,{"D1_LOJA"     , SDT->DT_LOJA            ,NIL})
	aAdd(alItens,{"D1_COD"      , SDT->DT_COD             ,NIL})
	aAdd(alItens,{"D1_QUANT"    , SDT->DT_QUANT           ,NIL})
	aAdd(alItens,{"D1_VUNIT"    , SDT->DT_VUNIT           ,NIL})
	aAdd(alItens,{"D1_TOTAL"    , SDT->DT_TOTAL 			,NIL})
	aAdd(alItens,{"D1_VALICM"   , SDT->DT_VLICMS   		,NIL})
	aAdd(alItens,{"D1_PICM"   	, SDT->DT_PCIM   		,NIL})
	aAdd(alItens,{"D1_BASEICM"  , SDT->DT_BICMS   		,NIL})
	aAdd(alItens,{"D1_BRICMS"   , SDT->DT_VBCST   		,NIL})
	aAdd(alItens,{"D1_ICMSRET"   , SDT->DT_VICMSST 		,NIL})

	if !empty(SDT->DT_PEDIDO)
		aAdd(alItens,{"D1_PEDIDO"  	, SDT->DT_PEDIDO       	  ,NIL})
		aAdd(alItens,{"D1_ITEMPC"  	, SDT->DT_ITEMPC       	  ,NIL})
	endif
/*
	if SDT->(DT_CSTPIS+DT_CSTCOF) = "0101"
		cTesDePara:=if(SX5->(dbseek(SPACE(2)+"Z1"+SB1->B1_TE)),alltrim(SX5->X5_DESCRI),SB1->B1_TE)
		aAdd(alItens,{"D1_TES"    , cTesDePara 		,NIL})
	else
*/
		aAdd(alItens,{"D1_TES"    , SB1->B1_TE   		,NIL})
//   endif
	aAdd(alRet,alItens)
	
	&(clTab)->(dbSkip())
enddo


Return alRet

/*

Descriao | Carrega Array com o cabecalho da nota fiscal para rotina automat.
Ĵ
Parametros clCodFor = Cod. Fornecedor                                       
          | clLoja   = Loja                                                  
          | clNota   = Num. NOta                                             
          | clSerie  = Serie                                                 
          | clTab    = Tabela de cabecalho - SDS                             
Ĵ
Retorno    alCabec = array com os dados para execucao da rotina automatica  
Ĵ
 Uso       ExecTela	                                                        
ٱ

*/
Static Function F1Imp(clCodFor,clLoja,clNota,clSerie,clTab)

Local alCabec:={}

 
DbSelectArea("SC7")
dbSetorder(1)

dbSelectarea("SDT")
dbSetOrder(2) //DT_FILIAL+DT_FORNEC+DT_LOJA+DT_DOC+DT_SERIE+DT_PRODFOR
dbSeek(xFilial("SDT")+clCodFor+clLoja+clNota+clSerie)
if SC7->(dbSeek(xfilial("SC7")+SDT->DT_PEDIDO))
	cCond:=SC7->C7_COND 
else
	cCond:="001"
endif


DbSelectArea("SF1")
dbSetorder(1)

dbSelectArea(clTab)
dbSetOrder(1)
&(clTab)->(dbGoTop())
If dbSeek(xFilial(clTab)+clNota+clSerie+clCodFor+clLoja)
	aAdd(alCabec,{"F1_TIPO"        ,SDS->DS_TIPO           ,Nil})
	aAdd(alCabec,{"F1_DOC"         ,SDS->DS_DOC            ,Nil})
	aAdd(alCabec,{"F1_SERIE"       ,SDS->DS_SERIE          ,Nil})
	aAdd(alCabec,{"F1_EMISSAO"     ,SDS->DS_EMISSA	    	 ,Nil})
	aAdd(alCabec,{"F1_FORNECE"     ,SDS->DS_FORNEC         ,Nil})
	aAdd(alCabec,{"F1_LOJA"        ,SDS->DS_LOJA           ,Nil})
	aAdd(alCabec,{"F1_ESPECIE"     ,SDS->DS_ESPECI         ,Nil})
	aAdd(alCabec,{"F1_COND"     	,cCond		         	,Nil})
	aAdd(alCabec,{"F1_FRETE"     	,SDS->DS_FRETE         	,Nil})
	aAdd(alCabec,{"F1_CHVNFE"      ,SDS->DS_CHAVENF  		,Nil})
EndIf
&(clTab)->(dbCloseArea())

Return alCabec

/*

Descriao | Rotina chamada no inicializador padro do campo DS_NOME (virtual)
          | posiciona na tabela correta (Fornecedor/Cliente) e retorna nome  
Ĵ
Parametros clCodFor = Cod. Fornecedor                                       
          | clLoja   = Loja                                                  
          | clTipo   = Tipo da Nota (NORMAL/DEVOLUCAO/BENEFICIAMNETO)        
Ĵ
Retorno    clNomeRet = Nome do fornecedor ou cliente                        
Ĵ
 Uso       GENERICO		                                                    
ٱ

*/
USER Function XmlRetNome(clForCli,clLoja,clTipo)
Local clNomeRet := ""
Local clAlias   := Iif((AllTrim(clTipo)<>"N"),"SA1","SA2")
clNomeRet := POSICIONE(clAlias,1,(XFILIAL(clAlias)+clForCli+clLoja),(Right(clAlias,2)+"_NOME") )
Return clNomeRet

/*

Descriao | Grava relacinamento Produto x Produto do Pornecedor				
Ĵ
Parametros ExpC1 = Cod. Fornecedor|Cliente                                  
			  ExpC2 = Loja Fornecedor|Cliente                                  
			  ExpC3 = Nota Fiscal		                                        
			  ExpC4 = Serie da Nota                                            
			  ExpC5 = Produto Clinte/Fornecedor                                
			  ExpC6 = Cod. Produto		                                        
Ĵ
Retorno    Nil										                        
Ĵ
 Uso       SelePed, RPrdxPrdF, ProcPCxNFe, AtuSDT							
ٱ

*/
Static Function GPrdxPrdF(clCodForCli, clLoja, clNota, clSerie, cProdForCli, cProdEmp)
Local aArea		:= GetArea()
// Ŀ
// | GRAVA RELACIONAMENTO PARA PROXIMA IMPORTACAO |
// 
dbSelectArea("SDT")
SDT->(dbSetOrder(2))
If SDT->(dbSeek(xFilial("SDT")+clCodForCli+clLoja+clNota+clSerie+cProdForCli ))
	If RecLock("SDT",.F.)
		Replace DT_COD With cProdEmp
		SDT->(MsUnLock())
	EndIf
EndIf

RestArea( aArea )
Return Nil

/*

Descriao | Valida se existe amarrao entre Produto x Fornecedor/Cliente	   	     
Ĵ
Parametros ExpC1 = Cod. Fornecedor|Cliente                                 			 
			  ExpC2 = Loja Fornecedor|Cliente                                    		 
			  ExpC3 = Cod. Produto		                                          		 
			  ExpC4 = Tipo da Nota		                                          		 
Ĵ
Retorno    cProdEmp = Produto relacionado ao Forncedor/Cliente                		 
Ĵ
 Uso       ProcPCxNFe                                                        	     
ٱ

*/
Static Function PrdxForCli(clCodForCli, clLoja, clCodProd,clTipo)
Local cWAlias 	:= ""
Local cProdEmp	:= ""
Local nOrd		:= 1

If clTipo<>"N"
	cWAlias := "SA7"
	nOrd := RetOrder("SA7", "A7_FILIAL+A7_CLIENTE+A7_LOJA+A7_PRODUTO")
Else
	cWAlias := "SA5"
	nOrd	:= RetOrder("SA5", "A5_FILIAL+A5_FORNECE+A5_LOJA+A5_PRODUTO")
EndIf

DbSelectArea(cWAlias)
(cWAlias)->(DbSetOrder( nOrd ))

If ( (cWAlias)->(dbSeek(xFilial(cWAlias)+clCodForCli+clLoja+clCodProd )) )
	If cWAlias == "SA5"
		cProdEmp := SA5->A5_PRODUTO
	Else
		cProdEmp := SA7->A7_PRODUTO
	EndIf
EndIf
Return cProdEmp



/*

Descriao | Funcao pesquisa no SM0 para qual empresa/filial  destinado a NFe
Ĵ
Parametros clCGC = CNPJ informado no arquivo XML                            
Ĵ
Retorno    alRet = Array de 2 posicoes                                      
          | 		[ 1 ] = COD. EMPRESA                                        
          | 		[ 2 ] = COD. FILIAL                                         
Ĵ
 Uso       Generico                                                         
ٱ

*/
Static Function PesqCGC(clCGC)
Local alAreaSM0
Local aCodEmpFil:= {}

dbSelectArea("SM0")
alAreaSM0 := SM0->(GetArea())
dbGoTop()
Do While !eof() .and. !Empty(clCGC)
	If SM0->M0_CGC = clCGC
		aAdd(aCodEmpFil, {SM0->M0_CODIGO, SM0->M0_CODFIL})
		exit
	Endif
	dbSkip()
Enddo
RestArea(alAreaSM0)
Return aCodEmpFil
/*


Descricao  Funcao para leitura de XMLs de NFe no diretorio de download
			  e geracao da pre-nota de entrada.						  
͹
Uso        GENERICO			                                          
ͼ


*/
User Function ReadXML(cFile,lJob)

Local cProduto	:= CriaVar("B1_COD")
Local cXML      := ""
Local cError    := ""
Local cWarning  := ""
Local cCGC	    := ""
Local cTipoNF   := ""
Local cTabEmit  := ""
Local cDoc	    := ""
Local cSerie    := ""
Local cCodigo   := ""
Local cLoja	    := ""
Local cCampo1   := ""
Local cCampo2   := ""
Local cCampo3   := ""
Local cCampo4   := ""
Local cCampo5   := ""
Local cQuery    := ""
Local cNFECFAP  := SuperGetMV("MV_NFECFAP",.F.,"")
Local lFound    := .F.
Local lProces   := .T.
Local lCFOPEsp  := .T.
Local nY		:= 0
Local oFullXML  := NIL
Local oAuxXML   := NIL
Local oXML	    := NIL
Local aHeadSDS  := {}
Local aItemSDT  := {}
Local oDlg     
Local lStatus := .F.
Private cProduto2 := CriaVar("B1_COD")
Private cEmailAdm 	:= GETMV("MV_WFADMIN")
Private cEmailErro  := ""
Private cEOL := CHR(13)+CHR(10)
Private aItens    := {}
Private nX		:= 0

Private lMsErroAuto 	:= .F.
Private cStartPath 	:= GetPvProfString(GetEnvServer(),"StartPath","ERROR", cIniFile )+'NFE\ENTRADA\'+SM0->M0_CODIGO+SM0->M0_CODFIL+"\"
Private cStartLido	:= Trim(GetPvProfString(GetEnvServer(),"StartPath","ERROR", cIniFile )+'NFE\ENTRADA\')+"ARQUIVO_XML\"
Private c3StartPath	:= cStartLido+SM0->M0_CODIGO+SM0->M0_CODFIL+"\"	//MES empresa/filial
Private cStartError	:= Trim(GetPvProfString(GetEnvServer(),"StartPath","ERROR", cIniFile )+'NFE\ENTRADA\')+"ERRO\"
Private aDados :={}
Private aPedIttens :={}

MakeDir(c3StartPath) 
MakeDir(cStartPath) 

cAcao:="1"   // 1= ok, 2=erro 3=empresa errada

Default lJob := .T.

Private cLJ_NFESUP:=getmv("LJ_NFESUP")

Private lCTE:=.f.

dbSelectArea("SB1")
dbSetOrder(1)
dbSelectArea("SF4")
dbSetOrder(1)
dbSelectArea("SC7")
dbSetOrder(1)

If !File(cStartPath +cFile)
	If lJob
		ConOut(Replicate("=",80))
		ConOut("ReadXML Error:")
		ConOut("Arquivo: " +cFile)
		ConOut("Ocorrencia: Arquivo inexistente.")
		ConOut(Replicate("=",80))
	Else
		Aviso("Error","Arquivo " +cFile +" inexistente.",{"OK"},2,"ReadXML")
	EndIf
	lProces := .F.
Else
	cXML := MemoRead(cStartPath +cFile)
	
	//-- Nao processa conhecimentos de transporte
	If "</CTE>" $ Upper(cXML)
		lCTE :=.t.
	EndIf
	If !("<NFE" $ Upper(cXML)) .and. !lCTE
		msgbox("Esse XMML nao e valido, verifique se o mesmo 'e uma carta de correcao" )  
		return
	EndIf
	
	//-- Nao processa XML de outra empresa/filial
	If lProces .And. !(Substr(SM0->M0_CGC,0,8) $ cXML)
		lProces := .F.
		cAcao:="3"
	EndIf
EndIf

If lProces .and. lCTE
	oFullXML := XmlParserFile(cStartPath + cFile,"_",@cError,@cWarning)
	If Empty(oFullXML) .Or. !Empty(cError)
		If lJob
			ConOut(Replicate("=",80))
			ConOut("ReadXML Error:")
			ConOut("Arquivo: " +cFile)
			ConOut("Ocorrencia: " +cError)
			ConOut(Replicate("=",80))
		Else
			Aviso("Erro",cError,{"OK"},2,"ReadXML")
		EndIf
		//-- Move arquivo para pasta dos erros
		cArqTXT := cStartPath+cFile
		//copia o arquivo antes da transacao
		cNomNovArq  := cStartError+cFile
		If MsErase(cNomNovArq)
			__CopyFile(cArqTXT,cNomNovArq)
			FErase(cStartPath+cFile)
		EndIf
		lProces := .F.
	Else
		oXML    := oFullXML
		oAuxXML := oXML
		//-- Resgata o no inicial da Ct-e
		While !lFound
			oAuxXML := XmlChildEx(oAuxXML,"_CTE")
			If !(lFound := oAuxXML # NIL)
				For nX := 1 To XmlChildCount(oXML)
					oAuxXML  := XmlChildEx(XmlGetchild(oXML,nX),"_CTE")
					lFound := oAuxXML:_InfCte # Nil
					If lFound
						oXML := oAuxXML
						Exit
					EndIf
				Next nX
			EndIf

			If lFound
				oXML := oAuxXML
				Exit
			EndIf
		EndDo

		cCNPJInf := oXML:_INFCTE:_REM:_CNPJ:TEXT
		If lJob
			If SM0->M0_CGC # cCNPJInf
				cAcao:="3"
				Return(cAcao)
			EndIf
			
		Else
			If SM0->M0_CGC # cCNPJInf
				MsgStop("Este arquivo no pertence a esta Filial!","Ateno - COMMI010")
				cAcao:="3"
				Return(cAcao)
			EndIf
		EndIf
		//PEGA A IDENT
		If lJob
			cIdEnt := U_WSAT01GetIdEnt()
		EndIf
		//VERIFICA O STATUS NA RECEITA FEDERAL E EM CASO DE REJEICAO NAO IMPORTA
		cChvNFE:=Right(AllTrim(oXML:_InfCte:_Id:Text),44)
		lStatus := .F. //ConsNFeChave(cChvNFE,cIdEnt,lJob)
		If .F. //lStatus
			cEmailErro:="CTe com problemas de validao no site da receita, rotina Cancelada!"
			If !lJob
				MsgStop(cEmailErro,"COMMI010")
				cAcao:="2"
				Return(cAcao)
			Else
				//ENVIA E-MAIL
				U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML CTe entrada com Erros' ,"")
				cAcao:="2"
				Return(cAcao)
			EndIf
		EndIf
      
      cCnpjTransp:=oXML:_INFCTE:_EMIT:_CNPJ:TEXT
		dbSelectArea("SA2")
		dbSetOrder(3)
		dbSeek(xfilial("SA2")+cCnpjTransp)  
		
		cF1_FORNECE := SA2->A2_COD
		cF1_LOJA	:= SA2->A2_LOJA

		cF1_DOC		:= padr(oXML:_INFCTE:_IDE:_nCT:TEXT,9)
		cF1_SERIE	:= space(3)
		cD1_VUNIT	:= val(oXML:_INFCTE:_VPREST:_VTPREST:TEXT)
		cD1_TES		:= "203"    
		cD1_TES		:=if(SM0->M0_CODIGO = "01",cD1_TES,"017")
		cNFSF2 		:=strzero(val(oXML:_INFCTE:_REM:_INFNF:_NDOC:TEXT),9)
		cSerieNFS   :=strzero(val(oXML:_INFCTE:_REM:_INFNF:_SERIE:TEXT),3)

		nPosaDados:=ascan(aDados,{|x| x[1] =cF1_DOC})
		if nPosaDados = 0
			aadd(aDados,{cF1_DOC,cNFSF2,""})
			nPosaDados:=len(aDados)
		endif 

		dbSelectArea("SF1")
		dbSetorder(1) //F1_FILIAL+F1_DOC+F1_SERIE+F1_FORNECE+F1_LOJA+F1_TIPO
		if dbSeek(xfilial("SF1")+cF1_DOC+cF1_SERIE+cF1_FORNECE+cF1_LOJA)
			cEmailErro :="ReadXML Error:"+ENTER
			cEmailErro +="Arquivo: " +cFile+ENTER
			cEmailErro +="A nota fiscal numero "+cF1_DOC+cF1_SERIE+" j foi incuida no sistema."  +ENTER
			//ENVIA E-MAIL
			U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML CTE entrada com Erros' ,"")
			//-- Move arquivo para pasta dos erros
			cArqTXT := cStartPath+cFile
			//copia o arquivo antes da transacao
			cNomNovArq  := cStartError+cFile
			If MsErase(cNomNovArq)
				__CopyFile(cArqTXT,cNomNovArq)
				FErase(cStartPath+cFile)
			EndIf
		endif
		
		cDt :=oXML:_INFCTE:_IDE:_DHEMI:TEXT
		dDt :=ctod(Substr(cDt,9,2)+"/"+Substr(cDt,6,2)+"/"+Substr(cDt,3,2))
		dbSelectArea("SF2") // Necessario achar a NFS para saber qual UF foi enviada a venda
		dbSetorder(1) //F2_FILIAL+F2_DOC+F2_SERIE+F2_CLIENTE+F2_LOJA+F2_FORMUL
		if dbSeek(xfilial("SF2")+cNFSF2+cSerieNFS)
			cF2_EST:=SF2->F2_EST
			dbSelectArea("SD2")
			SD2->(dbSetOrder(3)) // D2_FILIAL+D2_DOC+D2_SERIE+D2_CLIENTE+D2_LOJA+D2_COD+D2_ITEM
			IF SD2->(dbSeek(XFILIAL("SD2")+SF2->(F2_DOC+F2_SERIE+F2_CLIENTE+F2_LOJA)))
				aDados[nPosaDados,3]=SD2->D2_PEDIDO
			    npos:=ascan(aPedido,SD2->D2_PEDIDO)
			    if npos = 0
			    	AADD(aPedido,SD2->D2_PEDIDO)
			    endif
				dbSelectArea("SZD")
				dbSetorder(1)
				SUA->(dbSeek(XFILIAL("SUA")+SD2->D2_PEDIDO))
				if dbSeek(XFILIAL("SZD")+SD2->D2_PEDIDO).AND.!EMPTY(SD2->D2_PEDIDO)	
					reclock("SZD",.F.)
					SZD->ZD_DTRETI	:=dDt 
					SZD->ZD_CONHEC :=padr(oXML:_INFCTE:_IDE:_nCT:TEXT,9)
					SZD->ZD_FRETE 	:=cD1_VUNIT
//					SZD->ZD_PESOT  :=val(oXML:_INFCTE:_INFCTENORM:_INFCARGA:_INFQ:_QCARGA:TEXT)
					SZD->ZD_FRETC  :=SUA->UA_FRETE    // CalcFrete()
					msUnlock()
				endif
			ENDIF
		else
			cF2_EST := oXML:_INFCTE:_DEST:_ENDERDEST:_UF:TEXT
		endif

		DbSelectArea("SDS")
		AADD(aHeadSDS,{;
		{"DS_FILIAL"	,xFilial("SDS")									},; //Filial
		{"DS_DOC"		,cF1_DOC	  											},; //Numero do Documento
		{"DS_SERIE"		,cF1_SERIE											},; //Serie
		{"DS_FORNEC"	,cF1_FORNECE										},; //Fornecedor
		{"DS_LOJA"		,cF1_LOJA 											},; //Loja do Fornecedor
		{"DS_EMISSA"	,dDt													},; //Data de Emisso
		{"DS_EST"		,oXML:_INFCTE:_IDE:_CUF:TEXT					},; //Estado de emissao da NF
		{"DS_TIPO"		,"N" 		 											},; //Tipo da Nota
		{"DS_FORMUL"	,"N" 													},; //Formulario proprio
		{"DS_DTDIGI"	,dDataBase 											},; //Dtda de digitaao
		{"DS_ESPECI"	,'CTE'												},; //Especie
		{"DS_ARQUIVO"	,AllTrim(cFile)									},; //Arquivo importado
		{"DS_STATUS"	," "													},; //Status
		{"DS_CHAVENF"	,cChvNFE												},; //Chave de Acesso da NF
		{"DS_VERSAO"	,oXML:_InfCTe:_versao:text						},; //Verso
		{"DS_USERIMP"	,Iif(!Empty(cUserName),cUserName,"JOB" ) 	},; //Usuario na importacao
		{"DS_XML"		,cXML													},; //Conteudo do XML
		{"DS_DATAIMP"	,dDataBase											},; //Data importacao do XML
		{"DS_HORAIMP"	,SubStr(Time(),1,5)								}}) //Hora importacao XML

		AADD(aItemSDT,{ ;
		{"DT_FILIAL" 	,xFilial("SDT")									},; //Filial
		{"DT_COD"		,"FR"													},; //Codigo do produto
		{"DT_ITEM"   	,"01"													},; //Item
		{"DT_QUANT"  	,1														},; //Qtde
		{"DT_VUNIT"		,CD1_VUNIT											},; //Vlor Unitrio
		{"DT_FORNEC"	,cF1_FORNECE										},; //Forncedor
		{"DT_LOJA"   	,cF1_LOJA											},; //Lja
		{"DT_DOC"    	,cF1_DOC												},; //DocmTo
		{"DT_SERIE"		,cF1_SERIE								   		},; //Serie
		{"DT_TOTAL"		,CD1_VUNIT											}}) //Vlor Total

		If !Empty(aItemSDT) .And. !Empty(aHeadSDS) .and. lProces

			Begin Transaction
			aHeadSDS:=aHeadSDS[1]
			//--Grava cabealho
			RecLock("SDS",.T.)
			For nX:=1	To Len(aHeadSDS)
				SDS->&(aHeadSDS[nX][1]):= aHeadSDS[nX][2]
			Next
			dbCommit()
			MsUnlock()
			//--Grava Itens
			For nX:=1 To Len(aItemSDT)
				RecLock("SDT",.T.)
				For nY:=1 To Len(aItemSDT[nX])
					SDT->&(aItemSDT[nX][nY][1]):= aItemSDT[nX][nY][2]
				Next
				dbCommit()
				MsUnlock()
			Next

			End Transaction
		endif
		
		dbSelectArea("SA2")
		dbSetOrder(1)
		dbSeek(xfilial("SA2")+cF1_FORNECE+cF1_LOJA)
		cUFFornec:=SA2->A2_EST
		recLock("SA2",.F.)
		SA2->A2_EST:=cF2_EST
		msUnlock()
				
		aCab:=aItem1:={}
		aCab := ;
		{{"F1_TIPO"		,'N'			,NIL},;
		{"F1_FORMUL"	,'N'			,NIL},;
		{"F1_DOC"		,cF1_DOC		,NIL},;
		{"F1_SERIE"		,cF1_SERIE		,NIL},;
		{"F1_EMISSAO"	,dDataBase		,NIL},;
		{"F1_FORNECE"	,cF1_FORNECE   	,NIL},;
		{"F1_LOJA"	    ,cF1_LOJA      	,NIL},;
		{"F1_COND" 	    ,"002"		 	,NIL},;
		{"F1_EST" 	    ,cF2_EST	 	,NIL},;
		{"F1_CHVNFE"    ,cChvNFE	 	,NIL},;
		{"F1_ESPECIE"	,'CTE'    		,NIL}}
 		
 		dbSelectArea("SB1")
 		dbSeek(XFILIAL("SB1")+PADR("FR",15))

		aItem1:= ;
		{{"D1_COD"		,"FR"			,NIL},;
		{"D1_QUANT"		,1				,NIL},;
		{"D1_VUNIT"		,CD1_VUNIT		,NIL},;
		{"D1_TOTAL"		,CD1_VUNIT		,NIL},;
		{"D1_CC"			,SB1->B1_CC		,NIL},;
		{"D1_TES"		,cD1_TES		,NIL}}
		
		MSExecAuto({|x,y,z| MATA103(x,y,z)},aCab,{aItem1},3)
		If lMsErroAuto
			cEmailErro :="ReadXML Error:"+ENTER
			cEmailErro +="Arquivo: " +cFile+ENTER
			cEmailErro +="Erro na incluso do documento de entrada"+ENTER
			//ENVIA E-MAIL
			U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML CTE entrada com Erros' ,"")
			//-- Move arquivo para pasta dos erros
			cArqTXT := cStartPath+cFile
			//copia o arquivo antes da transacao
			cNomNovArq  := cStartError+cFile
			If MsErase(cNomNovArq)
				__CopyFile(cArqTXT,cNomNovArq)
				FErase(cStartPath+cFile)
			EndIf
		EndIf
		
		dbSelectArea("SA2")
		dbSetOrder(1)
		dbSeek(xfilial("SA2")+cF1_FORNECE+cF1_LOJA)
		recLock("SA2",.F.)
		SA2->A2_EST:=cUFFornec
		msUnlock()

		for i=1 to len(aDados)
			dbSelectArea("SZM")
			dbSetOrder(1)
			IF !dbSeek(XFILIAL("SZM")+aDados[i,3]+"04")
				reclock("SZM",.T.)
				SZM->ZM_FILIAL	:=XFILIAL("SZM")
				SZM->ZM_PEDIDO	:=aDados[i,3]
				SZM->ZM_OPER   	:="04"
				SZM->ZM_DATA   	:=dDt
				SZM->ZM_HORA   	:=TIME()
				msUNLOCK()
			Endif                                                                               
//			U_SEND1MAIL(aDados[i,3],"04")
			cMesg+=aDados[i,1]+" "+aDados[i,2]+" "+aDados[i,3]+cEOL
		next i

		cArqTXT := cStartPath+cFile
		//copia o arquivo antes da transacao
		cNomNovArq  := c3StartPath+cFile
		If MsErase(cNomNovArq)
			__CopyFile(cArqTXT,cNomNovArq)
			FErase(cStartPath+cFile)
		EndIf
		
   endif

endif

lVerPedido:=.F.

If lProces .and. !lCTE
	oFullXML := XmlParserFile(cStartPath + cFile,"_",@cError,@cWarning)
	
	//-- Erro na sintaxe do XML
	If Empty(oFullXML) .Or. !Empty(cError)
		If lJob
			ConOut(Replicate("=",80))
			ConOut("ReadXML Error:")
			ConOut("Arquivo: " +cFile)
			ConOut("Ocorrencia: " +cError)
			ConOut(Replicate("=",80))
		Else
			Aviso("Erro",cError,{"OK"},2,"ReadXML")
		EndIf
		
		//-- Move arquivo para pasta dos erros
		cArqTXT := cStartPath+cFile
		//copia o arquivo antes da transacao
		cNomNovArq  := cStartError+cFile
		If MsErase(cNomNovArq)
			__CopyFile(cArqTXT,cNomNovArq)
			FErase(cStartPath+cFile)
		EndIf
		lProces := .F.
	Else
		oXML    := oFullXML
		oAuxXML := oXML
		
		//-- Resgata o no inicial da NF-e
		While !lFound
			oAuxXML := XmlChildEx(oAuxXML,"_NFE")
			If !(lFound := oAuxXML # NIL)
				For nX := 1 To XmlChildCount(oXML)
					oAuxXML  := XmlChildEx(XmlGetchild(oXML,nX),"_NFE")
					lFound := oAuxXML:_InfNfe # Nil
					If lFound
						oXML := oAuxXML
						Exit
					EndIf
				Next nX
			EndIf
			
			If lFound
				oXML := oAuxXML
				Exit
			EndIf
		EndDo
		//VERIFICAR PARA QUAL FILIAL SERA IMPORTADO
		cCNPJInf := oXML:_INFNFE:_DEST:_CNPJ:TEXT
		cVersao  := oXML:_INFNFE:_VERSAO:TEXT
		If lJob
			If SM0->M0_CGC # cCNPJInf
				cAcao:="3"
				Return(cAcao)
			EndIf
			
		Else
			If SM0->M0_CGC # cCNPJInf
				MsgStop("Este arquivo no pertence a esta Filial!","Ateno - COMMI010")
				cAcao:="3"
				Return(cAcao)
			EndIf
		EndIf
		//-- Verifica se este ID ja foi processado
		DbSelectArea("SDS")
		SDS->(DbSetOrder(2))
		lFound := SDS->(DbSeek(xFilial("SDS")+Right(AllTrim(oXML:_InfNfe:_Id:Text),44)))//Filial + Chave de acesso
		if !lFound
			DbSelectArea("SF1")
			SF1->(DbSetOrder(8))//F1_FILIAL+F1_DOC+F1_SERIE+F1_FORNECE+F1_LOJA+F1_TIPO
			lFound := SF1->(DbSeek(xFilial("SF1")+Right(AllTrim(oXML:_InfNfe:_Id:Text),44)))//Filial + Chave de acesso
		endif  
		//PEGA A IDENT
		If lJob
			cIdEnt := U_WSAT01GetIdEnt()
		EndIf
		
		//VERIFICA O STATUS NA RECEITA FEDERAL E EM CASO DE REJEICAO NAO IMPORTA
		lStatus := .F. //ConsNFeChave(Right(AllTrim(oXML:_InfNfe:_Id:Text),44),cIdEnt,lJob)
		
		If .F. //lStatus
			cEmailErro:="NFe com problemas de validao no site da receita, rotina Cancelada!"
			If !lJob
				MsgStop(cEmailErro,"COMMI010")
				cAcao:="2"
				Return(cAcao)
			Else
				//ENVIA E-MAIL
				U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML NFe entrada com Erros' ,"")
				cAcao:="2"
				Return(cAcao)
			EndIf
		EndIf
		
		If lFound
			If lJob
				cEmailErro :="ReadXML Error:"+ENTER
				cEmailErro +="Arquivo: " +cFile+ENTER
				cEmailErro +="Ocorrencia: ID de NFe ja registrado na NF " +SDS->(DS_DOC+"/"+DS_SERIE)+" do fornecedor " +SDS->(DS_FORNEC+"/"+DS_LOJA) +"."+ENTER
				//ENVIA E-MAIL
				U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML NFe entrada com Erros' ,"")
				msgbox(cEmailErro)
				ConOut(Replicate("=",80))
				ConOut("ReadXML Error:")
				ConOut("Arquivo: " +cFile)
				ConOut("Ocorrencia: ID de NFe ja registrado na NF " +SDS->(DS_DOC+"/"+DS_SERIE);
				+" do fornecedor " +SDS->(DS_FORNEC+"/"+DS_LOJA) +".")
				ConOut(Replicate("=",80))
			Else
				cDoc :=oXML:_InfNfe:_Ide:_nNF:Text
				cNome := oXML:_InfNfe:_EMIT:_XNOME:Text 
				Aviso("Erro","ID de NFe ja registrado no sistema " +cDoc;
				+" do fornecedor " +cNome+".",{"OK"},2,"ReadXML")
			EndIf
			
			//-- Move arquivo para pasta dos erros
			cArqTXT := cStartPath+cFile
			//copia o arquivo antes da transacao
			cNomNovArq  := cStartError+cFile
			If MsErase(cNomNovArq)
				__CopyFile(cArqTXT,cNomNovArq)
				FErase(cStartPath+cFile)
			EndIf
			
			lProces := .F.
		EndIf
		
		//-- Se ID valido
		//-- Extrai tag _InfNfe:_Det
		If lProces
			If ValType(oXML:_InfNfe:_Det) == "O"
				aItens := {oXML:_InfNfe:_Det}
			ElseIf ValType(oXML:_InfNfe:_Det) == "U"
				If lJob
					cEmailErro :="ReadXML Error:"+ENTER
					cEmailErro +="Arquivo: " +cFile+ENTER
					cEmailErro +="Ocorrencia: tag _InfNfe:_Det nao localizada."+ENTER
					//ENVIA E-MAIL
					U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML NFe entrada com Erros' ,"")
					msgbox(cEmailErro)
					
					ConOut(Replicate("=",80))
					ConOut("ReadXML Error:")
					ConOut("Arquivo: " +cFile)
					ConOut("Ocorrencia: tag _InfNfe:_Det nao localizada.")
					ConOut(Replicate("=",80))
				Else
					Aviso("Erro","Tag _InfNfe:_Det nao localizada.",{"OK"},2,"ReadXML")
				EndIf
				
				//-- Move arquivo para pasta dos erros
				cArqTXT := cStartPath+cFile
				//copia o arquivo antes da transacao
				cNomNovArq  := cStartError+cFile
				If MsErase(cNomNovArq)
					__CopyFile(cArqTXT,cNomNovArq)
					FErase(cStartPath+cFile)
				EndIf
				
				lProces := .F.
			Else
				aItens := oXML:_InfNfe:_Det
			EndIf
		EndIf
		
		//-- Se tag _InfNfe:_Det valida
		//-- Extrai CGC do fornecedor/cliente
		If lProces
			If "<CFOP>5902</CFOP>" $ cXML .or. "<CFOP>6902</CFOP>" $ cXML
				cTipoNF := "B"
			Else
				cTipoNF := "N"
			EndIf
			
			If ValType(oXML:_INFNFE:_EMIT:_CNPJ) <> "U"
				cCGC := oXML:_INFNFE:_EMIT:_CNPJ:Text
			ElseIf ValType(oXML:_INFNFE:_EMIT:_CPF) <> "U"
				cCGC := oXML:_INFNFE:_EMIT:_CPF:Text
			Else
				If lJob
					cEmailErro :="ReadXML Error:"+ENTER
					cEmailErro +="Arquivo: " +cFile+ENTER
					cEmailErro +="Ocorrencia: tag _CNPJ/_CPF ausente."+ENTER
					//ENVIA E-MAIL
					U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML NFe entrada com Erros' ,"")
					msgbox(cEmailErro)

					ConOut(Replicate("=",80))
					ConOut("ReadXML Error:")
					ConOut("Arquivo: " +cFile)
					ConOut("Ocorrencia: tag _CNPJ/_CPF ausente.")
					ConOut(Replicate("=",80))
				Else
					Aviso("Erro","Tag _CNPJ/_CPF ausente.",{"OK"},2,"ReadXML")
				EndIf
				
				//-- Move arquivo para pasta dos erros
				cArqTXT := cStartPath+cFile
				//copia o arquivo antes da transacao
				cNomNovArq  := cStartError+cFile
				If MsErase(cNomNovArq)
					__CopyFile(cArqTXT,cNomNovArq)
					FErase(cStartPath+cFile)
				EndIf
				
				lProces := .F.
			EndIf
		EndIf
		
		//-- Se tag CGC valida
		//-- Busca fornecedor/cliente na base
		If lProces
			cTabEmit := If(cTipoNF == "N","SA2","SA1")
			dbSelectArea(cTabEmit)
			dbSetOrder(3)
			If (cTabEmit)->(dbSeek(xFilial(cTabEmit)+cCGC))
				cCodigo := (cTabEmit)->&(Substr(cTabEmit,2,2)+"_COD")
				cLoja   := (cTabEmit)->&(Substr(cTabEmit,2,2)+"_LOJA")
			Else
				If lJob
					cEmailErro :="ReadXML Error:"+ENTER
					cEmailErro +="Arquivo: " +cFile+ENTER
					cEmailErro +="Ocorrencia: " +If(cTipoNF == "N","fornecedor","cliente") +" de CNJP/CPF numero " +cCGC +" inexistente na base."+ENTER
					//ENVIA E-MAIL
					U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML NFe entrada com Erros' ,"")
					msgbox(cEmailErro)
					
					ConOut(Replicate("=",80))
					ConOut("ReadXML Error:")
					ConOut("Arquivo: " +cFile)
					ConOut("Ocorrencia: " +If(cTipoNF == "N","fornecedor","cliente") +" de CNJP/CPF numero " +cCGC +" inexistente na base.")
					ConOut(Replicate("=",80))
				Else
					Aviso("Erro",If(cTipoNF == "N","Fornecedor","Cliente") +" de CNJP/CPF numero " +cCGC +" inexistente na base.",{"OK"},2,"ReadXML")
				EndIf
				
				//-- Move arquivo para pasta dos erros
				cArqTXT := cStartPath+cFile
				//copia o arquivo antes da transacao
				cNomNovArq  := cStartError+cFile
				If MsErase(cNomNovArq)
					__CopyFile(cArqTXT,cNomNovArq)
					FErase(cStartPath+cFile)
				EndIf
				
				lProces := .F.
			EndIf
		EndIf
		
		//-- Se fornecedor/cliente validado
		//-- Processa cabealho e itens
		If lProces
			cCampo1 := If(cTipoNF # "N","A7_PRODUTO","A5_PRODUTO")
			cCampo2 := If(cTipoNF # "N","A7_FILIAL","A5_FILIAL")
			cCampo3 := If(cTipoNF # "N","A7_CLIENTE","A5_FORNECE")
			cCampo4 := If(cTipoNF # "N","A7_LOJA","A5_LOJA")
			cCampo5 := If(cTipoNF # "N","A7_CODCLI","A5_CODPRF")
			
			cDoc   := StrZero(Val(AllTrim(oXML:_InfNfe:_Ide:_nNF:Text)),TamSx3("F1_DOC")[1])
			cSerie := StrZero(Val(AllTrim(oXML:_InfNfe:_Ide:_Serie:Text)),TamSx3("F1_SERIE")[1])
			
			//Ŀ
			// Grava os Dados do Cabecalho - SDS  
			//
			if cVersao = "2.00"
				dEmissao:=StoD(StrTran(AllTrim(oXML:_InfNfe:_Ide:_DEMI:Text),"-",""))
			else
				dEmissao:=StoD(StrTran(AllTrim(LEFT(oXML:_InfNfe:_Ide:_DHEMI:Text,10)),"-",""))
			endif 	
			 
			
			nFrete :=Iif(ValType("oXML:_InfNfe:_total:_ICMSTot:_vFrete")<>"U",val(oXML:_InfNfe:_total:_ICMSTot:_vFrete:text),0)
			DbSelectArea("SDS")
			AADD(aHeadSDS,{;
			{"DS_FILIAL"	,xFilial("SDS")													     	},; //Filial
			{"DS_CNPJ"		,cCGC																				},; //CGC
			{"DS_DOC"		,cDoc 																				},; //Numero do Documento
			{"DS_SERIE"		,cSerie 																			},; //Serie
			{"DS_FORNEC"	,cCodigo																			},; //Fornecedor
			{"DS_LOJA"		,cLoja 																				},; //Loja do Fornecedor
			{"DS_EMISSA"	,dEmissao																   			},; //Data de Emisso
			{"DS_EST"		,oXML:_INFNFE:_EMIT:_ENDEREMIT:_UF:TEXT												},; //Estado de emissao da NF
			{"DS_TIPO"		,cTipoNF 																	 		},; //Tipo da Nota
			{"DS_FORMUL"	,"N" 																		 		},; //Formulario proprio
			{"DS_DTDIGI"	,dDataBase 																	 		},; //Dtda de digitaao
			{"DS_ESPECI"	,"SPED"																		  		},; //Especie
			{"DS_ARQUIVO"	,AllTrim(cFile)																   		},; //Arquivo importado
			{"DS_STATUS"	," "																		   		},; //Status
			{"DS_CHAVENF"	,Iif(ValType("opNF:_InfNfe:_Id")<>"U",Right(AllTrim(oXML:_InfNfe:_Id:Text),44),"")},; //Chave de Acesso da NF
			{"DS_VERSAO"	,Iif(ValType("opNF:_InfNfe:_versao")<>"U",oXML:_InfNfe:_versao:text ,"")			},; //Verso
			{"DS_USERIMP"	,Iif(!Empty(cUserName),cUserName,"JOB" ) 											},; //Usuario na importacao
			{"DS_XML"		,cXML																			},; //Conteudo do XML
			{"DS_DATAIMP"	,dDataBase																			},; //Data importacao do XML
			{"DS_FRETE"		,nFrete																			 	},; //Data importacao do XML
			{"DS_HORAIMP"	,SubStr(Time(),1,5)																	}}) //Hora importacao XML
			
			cPedido:=space(6)
			cItemPC:=space(3)
			aProdUso	:={}
			aErrosPD	:={}
			aErrosPDC:={}
			
			lVerPedido:=.f.

			Begin Transaction
			
			aPedidos :={}
			For nX := 1 To Len(aItens)
				cProduto := AllTrim(aItens[nX]:_Prod:_cProd:Text)
				cDescric := AllTrim(aItens[nX]:_Prod:_xProd:Text)
				cQuery := "SELECT " +cCampo1 +", R_E_C_N_O_ RECNUM FROM " +RetSqlName(If(cTipoNF # "N","SA7","SA5"))
				cQuery += " WHERE D_E_L_E_T_ <> '*' AND "
				cQuery += cCampo2 +" = '" +xFilial(If(cTipoNF # "N","SA7","SA5")) +"' AND "
				cQuery += cCampo3 +" = '" +cCodigo +"' AND "
				cQuery += cCampo4 +" = '" +cLoja +"' AND "
				cQuery += cCampo5 +" = '" +cProduto +"'"
				If Select("XTRB1") > 0
					XTRB1->(dbCloseArea())
				EndIf
				TcQuery cQuery new Alias "XTRB1"
				nRegs := U_CountQry('XTRB1')
				dbgotop()
				cProduto2 := XTRB1->(&cCampo1)
				if nRegs>0 .and. !msgYesNo("O produto "+alltrim(cProduto)+" Possui amarrao com codigo Kolplast :"+cProduto2+" Responsa SIM se deseja usar essa amarrao.")
				  	nRegs:=0
				  	cProduto2:="" 
				  	cQuery :=" DELETE "+RetSqlName(If(cTipoNF # "N","SA7","SA5"))  
				  	cQuery +=" WHERE R_E_C_N_O_ = "+STR(XTRB1->RECNUM)  
		  			TCSQLEXEC(cQuery)
				endif
				If .t. // nRegs = 0
					
					If !lJob
						/*
						nOpcao:=Aviso("Erro",If(cTipoNF == "N","Fornecedor ","Cliente ") +cCodigo +"/" +cLoja;
						+" sem cadastro de Produto X " +If(cTipoNF == "N","Fornecedor","Cliente");
						+" para o cdigo " +cProduto +" "+alltrim(str(nx))+" de "+alltrim(str(len(aItens)))+"."+" Deseja Incluir ? ",{"Sim","Nao","Sair"},1,"ReadXML")
						
						If nOpcao=3
							msgbox("importao cancelada","Aviso","INFO")  
							DisarmTransaction()
							return		
						endif
						*/  
						nOpcao:=1
						If nOpcao=1
							nPedidos:=0
							lImpPed :=.f.
							if cTipoNF =="N" .and. msgYesNo("Essa Entrada possui pedido de compra ?") 		// verifica se existem pedidos de compra para o fornecedor
								lImpPed:=.T.									
							endif
							
							if !lImpPed // procura amarrao direto no cadastro de produto porque no achou pedido de compra
								if !msgYesNo("Deseja importar XLM sem estar viculado a um pedido de compra?")
									msgbox("Importao cancelada","Aviso","INFO")  
									DisarmTransaction()
									return		
								endif
								lOk:=.t.
								Private cCodFor	 := padr(aItens[nX]:_PROD:_CPROD:TEXT,15)
								Private cProduto2	 := SPACE(15)
								Private cDescLog	 := Space(30)
								Private cDescrFor	 := aItens[nX]:_PROD:_XPROD:TEXT
								Private oCodFor ,oCodLog  ,oDescLog  ,oDescrFor,oDlg
								DEFINE MSDIALOG oDlg TITLE "Tabela de amarracao PRODUTO x CLIENTE/FORNECEDOR" FROM C(178),C(181) TO C(323),C(844) PIXEL
								@ C(009),C(004) Say "CLIENTE/FORNECEDOR" Size C(071),C(008) COLOR CLR_BLACK PIXEL OF oDlg
								@ C(010),C(170) Say SM0->M0_NOME Size C(076),C(008) COLOR CLR_BLACK PIXEL OF oDlg
								@ C(020),C(004) MsGet oCodFor Var cCodFor Size C(060),C(009) COLOR CLR_BLACK Picture "@!" PIXEL OF oDlg
								@ C(020),C(170) MsGet oCodLog Var cProduto2 F3 "SB1" Size C(060),C(009) COLOR CLR_BLACK Picture "@!" PIXEL OF oDlg 
								@ C(035),C(004) GET oDescrFor Var cDescrFor MEMO Size C(142),C(034) PIXEL OF oDlg
								@ C(035),C(169) MsGet oDescLog Var cDescLog Size C(142),C(009) COLOR CLR_BLACK Picture "@!" PIXEL OF oDlg
								DEFINE SBUTTON FROM C(053),C(263) TYPE 1 ENABLE OF oDlg ACTION(oDlg:end())
								DEFINE SBUTTON FROM C(053),C(293) TYPE 2 ENABLE OF oDlg ACTION(oDlg:end(),lOk:=.f.)
								oCodFor:bWhen      := {|| .f. }
								oCodLog:bValid     := {|| Existcpo("SB1",cProduto2), cDescLog:=Posicione("SB1",1,XFILIAL("SB1")+cProduto2,"B1_DESC"),oDescLog:REFRESH() }
								oDescLog:bWhen      := {|| .f. }
								oDescrFor:bWhen      := {|| .f. }
								
								ACTIVATE MSDIALOG oDlg CENTERED

								if !lOk
									msgbox("importao cancelada","Aviso","INFO")  
									DisarmTransaction()
									return		
								endif

							endif
							/*
							if nPedidos > 1 .and. empty(cPedido)  // SE MAIS DE 1 PEDIDO, SECELICIONA O MESMO VIA TELA
								cPedido :=tlPedido(cCodigo,cLoja)
							endif
							*/
							if lImpPed
								cCodFor	 := padr(aItens[nX]:_PROD:_CPROD:TEXT,15)
								cDescrFor	 := padr(aItens[nX]:_PROD:_XPROD:TEXT,35)
								cPedido:=tlProduto(cCodigo,cLoja,cCodFor,cDescrFor)
								cProduto2:=substr(cPedido,11,15)
								aadd(aPedidos,cPedido)
								if empty(cProduto2)
									msgbox("importao cancelada","Aviso","INFO")  
									DisarmTransaction()
									return		
								endif
							endif
							
							If !Empty(cProduto2) .and. nRegs = 0
								
								If cTipoNF # "N"
									dbSelectArea("SA7")
									RecLock("SA7",.T.)
									A7_FILIAL 	:= xFilial("SA7")
									A7_CLIENTE 	:= cCodigo
									A7_LOJA 	:= cLoja
									A7_CODCLI   := cProduto
									A7_PRODUTO  := cProduto2
									MsUnlock()
								Else
									dbSelectArea("SA5")
									dbSetOrder(1) //A5_FILIAL+A5_FORNECE+A5_LOJA+A5_PRODUTO
									lAtualiz:=.f.
									if dbseek(xfilial("SA5")+cCodigo+cLoja+cProduto2)
										if empty(SA5->A5_CODPRF)
											RecLock("SA5",.F.)
											lAtualiz:=.t.
										endif
									else
										RecLock("SA5",.T.)
										lAtualiz:=.t.
									endif
									if lAtualiz
										A5_FILIAL 	:= xFilial("SA5")
										A5_FORNECE 	:= cCodigo
										A5_LOJA 	:= cLoja
										A5_NOME		:= Posicione("SA2",1,xFilial("SA2")+cCodigo,"A2_NOME")
										A5_CODPRF	:= cProduto
										A5_PRODUTO  := cProduto2
										A5_NOMPROD  := Posicione("SB1",1,xFilial("SB1")+cProduto2,"B1_DESC")
										MsUnlock()
									endif
								Endif
							EndIf
							
						EndIf
					Else
						if ascan(aErrosPDC,cProduto) = 0
							aadd(aErrosPDC,cProduto)
							aadd(aErrosPD,cProduto+" "+cDescric)
						ENDIF
						cEmailErro :="ReadXML Error:"+ENTER
						cEmailErro +="Arquivo: " +cFile+ENTER
						cEmailErro +="Ocorrencia: " +If(cTipoNF == "N","fornecedor ","cliente ") +cCodigo +"/" +cLoja
						cEmailErro +=" sem cadastro de Produto X " +If(cTipoNF == "N","Fornecedor","Cliente")+" para os seguintes codigos:"+ENTER
						for nj:=1 to len(aErrosPD)
							cEmailErro+=" - Codigo :" +aErrosPD[nj]+ENTER
						next nj
						cEmailErro+= ". Ser necessrio fazer amarrao pelo processo manual."+ENTER
					EndIf
					
				else
					// Verifica se existe pedido de compra para o produto ; fornecedor
					
					/*
					dbSelectArea("SB1")
					dbSetOrder(1)
					dbSeek(xfilial("SB1")+cProduto2)
					nVlunit	:= val(aItens[nX]:_Prod:_vUnCom:Text)
					cQuery:="SELECT * FROM SC7010 "
					cQuery+="WHERE C7_PRODUTO = '"+cProduto2+"' "
					cQuery+="AND C7_PRECO BETWEEN "+STR(nVlunit)+" * 0.98 AND "+STR(nVlunit)+" * 1.02 " +cEol
					cQuery+="AND C7_FORNECE='"+cCodigo+"'  " +cEol
					cQuery+="AND C7_LOJA='"+cLoja+"'  " +cEol
					cQuery+="AND C7_QUJE = 0 "
					cQuery+="AND D_E_L_E_T_='' " +cEol
					cQuery+="ORDER BY C7_DATPRF " +cEol
					If Select("XSC7") > 0
						XSC7->(dbCloseArea())
					EndIf
					TcQuery cQuery new Alias "XSC7"
					nQtde := u_countQry("XSC7")
					XSC7->(DBGOTOP())
					
					if nQtde = 0  .and. SB1->B1_TIPO $ "ME,MP,EM"    //SB1->B1_TIPO $ "ME,MP,EM"  TEM PEDIDOS DE COMPRA COLOCADOS 
						aadd(aErrosPD,cProduto+" "+cDescric)
						lVerPedido:=.t.
						cEmailErro :="ReadXML Error:"+ENTER
						cEmailErro +="Arquivo: " +cFile+ENTER
						cEmailErro +="Ocorrencia: " +If(cTipoNF == "N","fornecedor ","cliente ") +cCodigo +"/" +cLoja
						cEmailErro +=" Nao h pedido de compra para o produto "+alltrim(cProduto2)+" ou o valor da nota no XML no confere com o valor no pedido."+ENTER
						for nj:=1 to len(aErrosPD)
							cEmailErro+=" - Codigo :" +aErrosPD[nj]+ENTER
						next nj
					endif
					*/
				endif
				
			next nX
			
			if (len(aErrosPD) > 0  .AND. lJob) .OR. lVerPedido
				ConOut(Replicate("=",80))
				ConOut(cEmailErro)
				ConOut(Replicate("=",80))
				
				//ENVIA E-MAIL
				U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,'Importacao XML NFe. Processo Automatico com erros.' ,"")
				msgbox(cEmailErro)

				cArqTXT := cStartPath+cFile
				
				//copia o arquivo antes da transacao
				cNomNovArq  := cStartError+cFile
				If MsErase(cNomNovArq)
					__CopyFile(cArqTXT,cNomNovArq)
					FErase(cStartPath+cFile)
				EndIf
				lProces := .F.
				DisarmTransaction()
				
				return
			endif
			
			if lVerPedido
				msgAlert(cEmailErro)
				DisarmTransaction()

				return
			endif
			
			For nX := 1 To Len(aItens)

				cPedido :=aPedidos[nX]
				cProduto2:=substr(aPedidos[nX],11,15)
								
				IF !SB1->(dbSeek(xFilial("SB1")+cProduto2))
					msgbox("cdigo de produto invlido ajuste na amarrao produto X fornecedor: "+cProduto2)
					Return
				ENDIF
				SF4->(dbSeek(xFilial("SF4")+SB1->B1_TE))
				
				// CONSISTENCIA DE ENTRADA
				if SB1->B1_POSIPI <> aItens[nX]:_PROD:_NCM:TEXT
					cVerifica:="H diferena no NCM do produto COD: "+ALLTRIM(cProduto2)+". Valor no XML:  "+aItens[nX]:_PROD:_NCM:TEXT+" Valor Cad. Produto: "	+SB1->B1_POSIPI+cEol
					ConOut(Replicate("=",80))
					ConOut("ReadXML Error:")
					ConOut("Arquivo: " +cFile)
					ConOut("Ocorrencia: " +cVerifica+ENTER)
					ConOut(Replicate("=",80))
					
					cEmailErro :="ReadXML Error:"+ENTER
					cEmailErro +="Arquivo: " +cFile+ENTER
					cEmailErro +="Ocorrencia: "+cVerifica+ENTER
					//ENVIA E-MAIL
					U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,'Importacao XML NFe. Processo Automatico com erros.' ,"")
					msgbox(cEmailErro)
					cArqTXT := cStartPath+cFile
					//copia o arquivo antes da transacao
					cNomNovArq  := cStartError+cFile
					If MsErase(cNomNovArq)
						__CopyFile(cArqTXT,cNomNovArq)
						FErase(cStartPath+cFile)
					EndIf 
					if msgYesNo("Deseja ajustar o NCM")
					   dbSelectArea("SB1")
					   IF SB1->(dbSeek(xFilial("SB1")+cProduto2))
					   		reclock("SB1",.F.)
					   		SB1->B1_POSIPI :=aItens[nX]:_PROD:_NCM:TEXT
					   		msUnlock()
					   ENDIF
						lProces:=.T.
					endif
				endif
				
				SC7->(dbSeek(XFILIAL("SC7")+left(aPedidos[nX],6)))
				//Ŀ
				// Dados dos Itens - SDT	   
				//
				
				nVlunit	:= val(aItens[nX]:_Prod:_vUnCom:Text)
				nQtxml	:=val(aItens[nX]:_Prod:_qCom:Text)

				cPedido1 :=substr(aPedidos[nX],1,6)
				cItemPC :=substr(aPedidos[nX],7,4)

				DbSelectArea("SDT")
				//Ŀ
				//  DADOS DO PRODUTO      
				//

				// CSTICMS
				aCstICMS:={"00","10","20","30","40","41","50","51","60","70","90"}
				cCstICMS :=""
				nloop:=1
				do while nloop <= len(aCstICMS)
					oAuxXML := XmlChildEx(aItens[nX]:_IMPOSTO:_ICMS,"_ICMS"+aCstICMS[nloop] )   // PROCURA QUAL O CST ICMS VLIDO NO XML
					If lFound := oAuxXML # NIL
                    	cCmd := "aItens[nX]:_IMPOSTO:_ICMS:_ICMS"+aCstICMS[nloop]+":_CST:TEXT"
                    	cCstICMS:=&(cCmd)
                    	exit
					endif
					nloop++
				enddo
				cCstpis:=""
				cCstcof:=""
				
				//CSTPIS  E CSTCOFINS
				oAuxXML := XmlChildEx(aItens[nX]:_IMPOSTO:_PIS,"_PISALIQ")   // PROCURA QUAL O CST PIS VLIDO NO XML
				If lFound := oAuxXML # NIL  
					cCstpis:=aItens[nX]:_IMPOSTO:_PIS:_PISALIQ:_CST:TEXT
				endif
				oAuxXML := XmlChildEx(aItens[nX]:_IMPOSTO:_PIS,"_PISNT")   // PROCURA QUAL O CST PIS VLIDO NO XML
				If lFound := oAuxXML # NIL  
					cCstpis:=aItens[nX]:_IMPOSTO:_PIS:_PISNT:_CST:TEXT
				endif
				cCstcof:=cCstpis

				//CSTIPI
				cCstIPI:=""

				oAuxXML := XmlChildEx(aItens[nX]:_IMPOSTO,"_IPI")   // PROCURA QUAL O CST IPI VLIDO NO XML
				If lFound := oAuxXML # NIL  
					oAuxXML := XmlChildEx(aItens[nX]:_IMPOSTO:_IPI,"_IPINT")   // PROCURA QUAL O CST IPI VLIDO NO XML
					If lFound := oAuxXML # NIL  
						oAuxXML := XmlChildEx(aItens[nX]:_IMPOSTO:_IPI:_IPINT,"_CST")   // PROCURA QUAL O CST IPI VLIDO NO XML
						If lFound := oAuxXML # NIL  
							cCstIPI:=aItens[nX]:_IMPOSTO:_IPI:_IPINT:_CST:TEXT
						endif
					endif
			    endif

				//  TRATAMENTO DO QUANTIDADE
			    dbSelectArea("SB1")
				SB1->(dbSeek(xFilial("SB1")+cProduto2))
				nQtdeXml :=Val(aItens[nX]:_Prod:_qCom:Text)
				nVlUnit := Round(Val(aItens[nX]:_Prod:_vUnCom:Text),TamSX3("C7_PRECO")[2])
				
				IF  SB1->B1_SEGUM = aItens[nX]:_Prod:_UCOM:Text
                	if SB1->B1_TIPCONV = "M"
                   		nQtdeXml :=nQtdeXml/SB1->B1_CONV		
                	else
                   		nQtdeXml :=nQtdeXml*SB1->B1_CONV		
                	endif	
					nVlUnit := Round(Val(aItens[nX]:_Prod:_vProd:Text)/nQtdeXml ,TamSX3("C7_PRECO")[2])
				ENDIF               
				                             
				//  TRATAMENTO DO QUANTIDADE

				// CSTICMS
				aCstICMS:={"00","10","20","30","40","41","50","51","60","70","90"}
				cCstICMS :=""
				C_BICMS		:=0
				C_PCIM	 	:=0
				C_VLICMS	:=0
				C_VBCST		:=0
				C_PICMSST 	:=0
				C_VICMSST	:=0
				nloop:=1
				do while nloop <= len(aCstICMS)
					oAuxXML := XmlChildEx(aItens[nX]:_IMPOSTO:_ICMS,"_ICMS"+aCstICMS[nloop] )   // PROCURA QUAL O CST ICMS VLIDO NO XML
					If lFound := oAuxXML # NIL
                    	cCstICMS:=aCstICMS[nloop]
						IF XmlChildEx(oAuxXML,"_VBC") # NIL  // VERIFICA A EXISTENCIA DO CAMPO VBC
							C_BICMS  :=val(oAuxXML:_VBC:TEXT)   
							C_PCIM 	 :=val(oAuxXML:_PICMS:TEXT)
							C_VLICMS :=val(oAuxXML:_VICMS:TEXT)
							if cCstICMS $ "10,70"
								C_VBCST:=VAL(oAuxXML:_VBCST:TEXT)
								C_PICMSST:=VAL(oAuxXML:_PICMSST:TEXT)
								C_VICMSST:=VAL(oAuxXML:_VICMSST:TEXT)        
							endif
						endif
                    	exit
					endif
					nloop++
				enddo

				AADD(aItemSDT,{ ;
				{"DT_FILIAL" 	,xFilial("SDT")														},; //Filial
				{"DT_CNPJ"		,cCGC																},; //CGC
				{"DT_COD"		,cProduto2															},; //Codigo do produto
				{"DT_PRODFOR"	,aItens[nX]:_PROD:_CPROD:TEXT										},; //Cdgo do pduto do Fornecedor
				{"DT_DESCFOR"	,aItens[nX]:_PROD:_XPROD:TEXT										},; //Dcao do pduto do Fornecedor
				{"DT_ITEM"   	,PadL(aItens[nX]:_nItem:Text,TamSX3("D1_ITEM")[1],"0")				},; //Item
				{"DT_QUANT"  	,nQtdeXml															},; //Qtde
				{"DT_VUNIT"		,nVlUnit															},; //Vlor Unitrio
				{"DT_FORNEC"	,cCodigo																},; //Forncedor
				{"DT_LOJA"   	,cLoja																	},; //Lja
				{"DT_DOC"    	,cDoc																		},; //DocmTo
				{"DT_SERIE"		,cSerie							   									},; //Serie
				{"DT_PEDIDO"	,cPedido1						   									},; //Pedido
				{"DT_ITEMPC"	,cItemPC						   									},; //Pedido
				{"DT_NCM"		,aItens[nX]:_PROD:_NCM:TEXT	  										},; //NCM
				{"DT_CFOP"		,aItens[nX]:_PROD:_CFOP:TEXT   										},; //CFOP
				{"DT_CFICMS"	,cCstICMS															},; //NCM PIS
				{"DT_CLPIS"		,cCstpis															},; //NCM PIS
				{"DT_CLCOF"		,cCstcof															},; //NCM COFINS
				{"DT_CLIPI"		,cCstIPI															},; //NCM COFINS
				{"DT_TOTAL"		,Val(aItens[nX]:_Prod:_vProd:Text)									},; //Vlor Total
				{"DT_BICMS "	,C_BICMS															},; //NCM PIS
				{"DT_PCIM"		,C_PCIM																},; //NCM PIS
				{"DT_VLICMS"	,C_VLICMS															},; //NCM PIS
				{"DT_VBCST"		,C_VBCST					   										},; //CFOP
				{"DT_PICMSST"	,C_PICMSST															},; //NCM PIS
				{"DT_VICMSST"	,C_VICMSST															}})

			Next nX
			
			If !Empty(aItemSDT) .And. !Empty(aHeadSDS) .and. lProces
				//Ŀ
				//Grava os dados do cabealho e itens da nota importada do XML
				//
				aHeadSDS:=aHeadSDS[1]
				//--Grava cabealho
				RecLock("SDS",.T.)
				For nX:=1	To Len(aHeadSDS)
					SDS->&(aHeadSDS[nX][1]):= aHeadSDS[nX][2]
				Next
				dbCommit()
				MsUnlock()
				//--Grava Itens
				For nX:=1 To Len(aItemSDT)
					RecLock("SDT",.T.)
					For nY:=1 To Len(aItemSDT[nX])
						SDT->&(aItemSDT[nX][nY][1]):= aItemSDT[nX][nY][2]
					Next
					dbCommit()
					MsUnlock()
				Next
				
				cArqTXT := cStartPath+cFile
				//copia o arquivo antes da transacao
				cNomNovArq  := c3StartPath+cFile
				If MsErase(cNomNovArq)
					__CopyFile(cArqTXT,cNomNovArq)
					FErase(cStartPath+cFile)
				EndIf
								
				cEmailErro :="ReadXML Status:"+ENTER
				cEmailErro +="Arquivo: " +cFile+ENTER
				cEmailErro +="XML importado com sucesso"+ENTER
				//ENVIA E-MAIL
				U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML NFe entrada com Sucesso' ,"")
				msgbox(cEmailErro)

				conout(cEmailErro)
				
				cAcao:="1"
			Else
				//-- Move arquivo para pasta dos erros
				cArqTXT := cStartPath+cFile
				//copia o arquivo antes da transacao
				cNomNovArq  := cStartError+cFile
				If MsErase(cNomNovArq)
					__CopyFile(cArqTXT,cNomNovArq)
					FErase(cStartPath+cFile)
				EndIf
				cEmailErro :="ReadXML Status:"+ENTER
				cEmailErro +="Arquivo: " +cFile+ENTER
				cEmailErro +="XML Nao foi importado com sucesso."+ENTER
				//ENVIA E-MAIL
				U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML NFe entrada Erro' ,"")
				msgbox(cEmailErro)
			EndIf

			End Transaction			

		EndIf
	EndIf
EndIf

Return(cAcao)

/*


Desc.                                                                 
                                                                      
͹
Uso        AP                                                        
ͼ


*/
Static Function ConsNFeChave(cChaveNFe,cIdEnt,lWeb)

Local cURL     := PadR(GetNewPar("MV_SPEDURL","http://"),250)
Local cMensagem:= ""
Local oWS
Local lErro := .F.


If ValType(lWeb) == 'U'
	lWeb := .F.
EndIf

oWs:= WsNFeSBra():New()
oWs:cUserToken   := "TOTVS"
oWs:cID_ENT    := cIdEnt
ows:cCHVNFE		 := cChaveNFe
oWs:_URL         := AllTrim(cURL)+"/NFeSBRA.apw"

If oWs:ConsultaChaveNFE()
	cMensagem := ""
	If !Empty(oWs:oWSCONSULTACHAVENFERESULT:cVERSAO)
		cMensagem += "Verso da Mensagem"+": "+oWs:oWSCONSULTACHAVENFERESULT:cVERSAO+CRLF
	EndIf
	cMensagem += "Ambiente"+": "+IIf(oWs:oWSCONSULTACHAVENFERESULT:nAMBIENTE==1,"Produo","Homologao")+CRLF //"Produo"###"Homologao"
	cMensagem += "Cod.Ret.NFe"+": "+oWs:oWSCONSULTACHAVENFERESULT:cCODRETNFE+CRLF
	cMensagem += "Msg.Ret.NFe"+": "+oWs:oWSCONSULTACHAVENFERESULT:cMSGRETNFE+CRLF
	If !Empty(oWs:oWSCONSULTACHAVENFERESULT:cPROTOCOLO)
		cMensagem += "Protocolo"+": "+oWs:oWSCONSULTACHAVENFERESULT:cPROTOCOLO+CRLF
	EndIf
	//QUANDO NAO ESTIVER OK NAO IMPORTA, CODIGO DIFERENTE DE 100
	If oWs:oWSCONSULTACHAVENFERESULT:cCODRETNFE # "100"
		lErro := .T.
	EndIf
	
	If !lWeb
		Aviso("Consulta NF",cMensagem,{"Ok"},3)
	Else
		Return({lErro,cMensagem})
	EndIf
Else
	Aviso("SPED",IIf(Empty(GetWscError(3)),GetWscError(1),GetWscError(3)),{"Ok"},3)
EndIf
Return(lErro)

/*/


Descrio Obtem o codigo da entidade apos enviar o post para o Totvs  
          Service                                                     
Ĵ
Retorno   ExpC1: Codigo da entidade no Totvs Services                 
Ĵ
ParametrosNenhum                                                      
Ĵ
   DATA    Programador   Manutencao efetuada                         
Ĵ
                                                                     
ٱ


/*/
User Function WSAT01GetIdEnt()

Local aArea  := GetArea()
Local cIdEnt := ""
Local cURL   := PadR(GetNewPar("MV_SPEDURL","http://"),250)
Local oWs
//Ŀ
//Obtem o codigo da entidade                                              
//
oWS := WsSPEDAdm():New()
oWS:cUSERTOKEN := "TOTVS"

oWS:oWSEMPRESA:cCNPJ       := IIF(SM0->M0_TPINSC==2 .Or. Empty(SM0->M0_TPINSC),SM0->M0_CGC,"")
oWS:oWSEMPRESA:cCPF        := IIF(SM0->M0_TPINSC==3,SM0->M0_CGC,"")
oWS:oWSEMPRESA:cIE         := SM0->M0_INSC
oWS:oWSEMPRESA:cIM         := SM0->M0_INSCM
oWS:oWSEMPRESA:cNOME       := SM0->M0_NOMECOM
oWS:oWSEMPRESA:cFANTASIA   := SM0->M0_NOME
oWS:oWSEMPRESA:cENDERECO   := FisGetEnd(SM0->M0_ENDENT)[1]
oWS:oWSEMPRESA:cNUM        := FisGetEnd(SM0->M0_ENDENT)[3]
oWS:oWSEMPRESA:cCOMPL      := FisGetEnd(SM0->M0_ENDENT)[4]
oWS:oWSEMPRESA:cUF         := SM0->M0_ESTENT
oWS:oWSEMPRESA:cCEP        := SM0->M0_CEPENT
oWS:oWSEMPRESA:cCOD_MUN    := SM0->M0_CODMUN
oWS:oWSEMPRESA:cCOD_PAIS   := "1058"
oWS:oWSEMPRESA:cBAIRRO     := SM0->M0_BAIRENT
oWS:oWSEMPRESA:cMUN        := SM0->M0_CIDENT
oWS:oWSEMPRESA:cCEP_CP     := Nil
oWS:oWSEMPRESA:cCP         := Nil
oWS:oWSEMPRESA:cDDD        := Str(FisGetTel(SM0->M0_TEL)[2],3)
oWS:oWSEMPRESA:cFONE       := AllTrim(Str(FisGetTel(SM0->M0_TEL)[3],15))
oWS:oWSEMPRESA:cFAX        := AllTrim(Str(FisGetTel(SM0->M0_FAX)[3],15))
oWS:oWSEMPRESA:cEMAIL      := UsrRetMail(RetCodUsr())
oWS:oWSEMPRESA:cNIRE       := SM0->M0_NIRE
oWS:oWSEMPRESA:dDTRE       := SM0->M0_DTRE
oWS:oWSEMPRESA:cNIT        := IIF(SM0->M0_TPINSC==1,SM0->M0_CGC,"")
oWS:oWSEMPRESA:cINDSITESP  := ""
oWS:oWSEMPRESA:cID_MATRIZ  := ""
oWS:oWSOUTRASINSCRICOES:oWSInscricao := SPEDADM_ARRAYOFSPED_GENERICSTRUCT():New()
oWS:_URL := AllTrim(cURL)+"/SPEDADM.apw"
If oWs:ADMEMPRESAS()
	cIdEnt  := oWs:cADMEMPRESASRESULT
Else
	Aviso("SPED",IIf(Empty(GetWscError(3)),GetWscError(1),GetWscError(3)),{"Ok"},3)
EndIf

RestArea(aArea)
Return(cIdEnt)



/*

Ŀ
Programa  LJP001     Autor  Marcelo Lopes          Data 20/09/2012
Ĵ
Locacao    Consultoria      Contato  marcelo@absystem.com.br        
Ĵ
Descricao                                                             
Ĵ
Parametros                                                            
Ĵ
Retorno                                                               
Ĵ
Aplicacao                                                             
Ĵ
Uso                                                                   
Ĵ
Analista Resp.  Data   Bops  Manutencao Efetuada                    
Ĵ
                /  /                                                
                /  /                                                
ٱ

*/
Static Function tlPedido(cCodigo,cLoja)
// Variaveis Locais da Funcao
Local cGet1	 := cCodigo
Local cGet2	 := posicione("SA2",1,xfilial("SA2")+cCodigo+cLoja,"A2_NOME")
Local oGet1
Local oGet2
// Variaveis Private da Funcao
Private oDlg				// Dialog Principal
// Privates das ListBoxes
Private aListBox1 := {}
Private oListBox1

DEFINE MSDIALOG oDlg TITLE "Selecione o Pedido" FROM C(178),C(181) TO C(623),C(713) PIXEL

	@ C(008),C(014) TO C(048),C(251) LABEL "Dados do Fornecedor" PIXEL OF oDlg
	@ C(017),C(026) Say "Codigo" Size C(052),C(008) COLOR CLR_BLACK PIXEL OF oDlg
	@ C(017),C(102) Say "Nome" Size C(045),C(008) COLOR CLR_BLACK PIXEL OF oDlg
	@ C(027),C(026) MsGet oGet1 Var cGet1 Size C(060),C(009) COLOR CLR_BLACK Picture "@!" PIXEL OF oDlg
	@ C(027),C(102) MsGet oGet2 Var cGet2 Size C(130),C(009) COLOR CLR_BLACK Picture "@!" PIXEL OF oDlg
	DEFINE SBUTTON FROM C(201),C(226) TYPE 1 ENABLE OF oDlg ACTION(oDlg:end())

	// Cria ExecBlocks dos Componentes Padroes do Sistema
	oGet1:bWhen      := {|| .F. }
	oGet2:bWhen      := {|| .F. }

	// Chamadas das ListBox do Sistema
	fListBox1(cCodigo,cLoja)

ACTIVATE MSDIALOG oDlg CENTERED 

cRet:=space(6)
for nj:=1 to len(aListBox1)
	if aListBox1[nj,1]
	   cRet:=aListBox1[nj,2]	
	endif
next nj
Return(cRet)

/*

Ŀ
Programa   fListBox1()  Autor  Marcelo Lopes          Data 20/09/2012
Ĵ
Descricao   Montagem da ListBox                                          
ٱ

*/
Static Function fListBox1(cCodigo,cLoja)
Local oOk 	   := LoadBitmap( GetResources(), "LBOK"       )
Local oNo 	   := LoadBitmap( GetResources(), "LBNO"       )

	// Carrege aqui sua array da Listbox

	cQuery:="SELECT C7_NUM,C7_EMISSAO FROM "+retSqlName("SC7")+" " +cEol
	cQuery+="WHERE C7_FORNECE='"+cCodigo+"' " +cEol
	cQuery+="AND C7_LOJA='"+cLoja+"' " +cEol
	cQuery+="AND C7_QUJE < C7_QUANT " +cEol
	cQuery+="AND C7_FILIAL = '"+XFILIAL("SC7")+"' " +cEol
	cQuery+="AND D_E_L_E_T_='' " +cEol  
//	cQuery+="AND NOT EXISTS(SELECT C7_NUM FROM "+retSqlName("SDT")+" WHERE DT_FILIAL=C7_FILIAL AND C7_NUM=DT_PEDIDO) " +cEol
	cQuery+="GROUP BY C7_NUM,C7_EMISSAO " +cEol
	If Select("XSC7") > 0
		XSC7->(dbCloseArea())
	EndIf
	TcQuery cQuery new Alias "XSC7"
	TcSetField("XSC7","C7_EMISSAO","D",08,0)
	
	do while XSC7->(!eof())  
		Aadd(aListBox1,{.F.,XSC7->C7_NUM,XSC7->C7_EMISSAO})
  	XSC7->(dbSkip())
  enddo
  
	@ C(058),C(012) ListBox oListBox1 Fields ;
		HEADER "","PEDIDO","EMISSAO";
		Size C(239),C(137) Of oDlg Pixel;
		ColSizes 50,50;
	On DBLCLICK ( aListBox1[oListBox1:nAt,1] := !(aListBox1[oListBox1:nAt,1]), oListBox1:Refresh() )
	oListBox1:SetArray(aListBox1)

	// Cria ExecBlocks das ListBoxes
	oListBox1:bLine 		:= {|| {;
	If(aListBox1[oListBox1:nAT,1],oOk,oNo),;
		aListBox1[oListBox1:nAT,02],;
		aListBox1[oListBox1:nAT,03]}}

Return Nil                                                                                                                      



/*

Ŀ
Programa  LJP001     Autor  Marcelo Lopes          Data 20/09/2012
Ĵ
Locacao    Consultoria      Contato  marcelo@absystem.com.br        
Ĵ
Descricao                                                             
Ĵ
Parametros                                                            
Ĵ
Retorno                                                               
Ĵ
Aplicacao                                                             
Ĵ
Uso                                                                   
Ĵ
Analista Resp.  Data   Bops  Manutencao Efetuada                    
Ĵ
                /  /                                                
                /  /                                                
ٱ

*/
Static Function tlProduto(cCodigo,cLoja,cCodFor,cDescrFor)
// Variaveis Locais da Funcao
Local cGet1	 := cCodFor
Local cGet2	 := cDescrFor
Local oGet1
Local oGet2
Private lOk :=.f.

// Variaveis Private da Funcao
Private oDlg				// Dialog Principal
// Privates das ListBoxes
Private aListBox1 := {}
Private oListBox1

DEFINE MSDIALOG oDlg TITLE "Selecione Amarraao Produto X Fornecedor" FROM C(178),C(181) TO C(623),C(713) PIXEL

	// Cria as Groups do Sistema
	@ C(008),C(014) TO C(048),C(251) LABEL "Dados do Produto no XML da NOTA FISCAL " PIXEL OF oDlg

	// Cria Componentes Padroes do Sistema
	@ C(017),C(026) Say "Produto" Size C(052),C(008) COLOR CLR_BLACK PIXEL OF oDlg
	@ C(017),C(102) Say "Descrio" Size C(045),C(008) COLOR CLR_BLACK PIXEL OF oDlg
	@ C(027),C(026) MsGet oGet1 Var cGet1 Size C(060),C(009) COLOR CLR_BLACK Picture "@!" PIXEL OF oDlg
	@ C(027),C(102) MsGet oGet2 Var cGet2 Size C(130),C(009) COLOR CLR_BLACK Picture "@!" PIXEL OF oDlg
	DEFINE SBUTTON FROM C(201),C(200) TYPE 1 ENABLE OF oDlg ACTION(lOk:=.t.,odlg:end())
	DEFINE SBUTTON FROM C(201),C(230) TYPE 2 ENABLE OF oDlg ACTION(lOk:=.f.,odlg:end())

	// Cria ExecBlocks dos Componentes Padroes do Sistema
	oGet1:bWhen      := {|| .F. }
	oGet2:bWhen      := {|| .F. }

	// Chamadas das ListBox do Sistema
	fListBox2(cCodigo,cLoja)

ACTIVATE MSDIALOG oDlg CENTERED 

cRet:=space(15)
for nj:=1 to len(aListBox1)
	if aListBox1[nj,1] .and. lOk
	   cRet:=aListBox1[nj,2]+aListBox1[nj,3]+aListBox1[nj,4]
	   aadd(aPedIttens,{aListBox1[nj,2],aListBox1[nj,3],aListBox1[nj,4]})
	endif
next nj
Return(cRet)


/*

Ŀ
Programa   fListBox1()  Autor  Marcelo Lopes          Data 20/09/2012
Ĵ
Descricao   Montagem da ListBox                                          
ٱ

*/
Static Function fListBox2(cCodigo,cLoja)
Local oOk 	   := LoadBitmap( GetResources(), "LBOK"       )
Local oNo 	   := LoadBitmap( GetResources(), "LBNO"       )

	// Carrege aqui sua array da Listbox
	cQuery:="SELECT * FROM "+retSqlName("SC7")+" " +cEol
	cQuery+="WHERE C7_FORNECE='"+cCodigo+"' " +cEol
	cQuery+="AND C7_LOJA='"+cLoja+"' " +cEol
	cQuery+="AND C7_QUJE < C7_QUANT " +cEol
	cQuery+="AND C7_FILIAL = '"+XFILIAL("SC7")+"' " +cEol
	if !empty(cProduto2)
		cQuery+="AND C7_PRODUTO='"+cProduto2+"' " +cEol
	endif
	cQuery+="AND D_E_L_E_T_='' " +cEol  
	If Select("XSC7") > 0
		XSC7->(dbCloseArea())
	EndIf
	TcQuery cQuery new Alias "XSC7"
	do while XSC7->(!eof())  
		nPos:=ascan(aPedIttens,{|x| x[1]=XSC7->C7_NUM .and. x[2]=XSC7->C7_ITEM .and.XSC7->C7_PRODUTO})
		if nPos=0
			Aadd(aListBox1,{.F.,XSC7->C7_NUM,XSC7->C7_ITEM,XSC7->C7_PRODUTO,XSC7->C7_DESCRI,STOD(XSC7->C7_DATPRF) })
		endif
  		XSC7->(dbSkip())
	enddo
	if len(aListBox1) = 0
		Aadd(aListBox1,{.F.,SPACE(15),SPACE(40)})
	endif

	@ C(058),C(012) ListBox oListBox1 Fields ;
		HEADER "","Pedido","Item","Codigo","Descricao","Entrega"  ;
		Size C(239),C(137) Of oDlg Pixel;
		ColSizes 50,50,50,50,50;
	On DBLCLICK ( aListBox1[oListBox1:nAt,1] := !(aListBox1[oListBox1:nAt,1]), oListBox1:Refresh() )
	oListBox1:SetArray(aListBox1)

	// Cria ExecBlocks das ListBoxes
	oListBox1:bLine 		:= {|| {;
	If(aListBox1[oListBox1:nAT,1],oOk,oNo),;
		aListBox1[oListBox1:nAT,02],;
		aListBox1[oListBox1:nAT,03],;
		aListBox1[oListBox1:nAT,04],;
		aListBox1[oListBox1:nAT,05],;
		aListBox1[oListBox1:nAT,06]}}

Return Nil                                                                                                                      



Static Function C(nTam)                                                         
Local nHRes	:=	oMainWnd:nClientWidth	// Resolucao horizontal do monitor     
	If nHRes == 640	// Resolucao 640x480 (soh o Ocean e o Classic aceitam 640)  
		nTam *= 0.8                                                                
	ElseIf (nHRes == 798).Or.(nHRes == 800)	// Resolucao 800x600                
		nTam *= 1                                                                  
	Else	// Resolucao 1024x768 e acima                                           
		nTam *= 1.28                                                               
	EndIf                                                                         
                                                                                
	//Ŀ                                               
	//Tratamento para tema "Flat"                                               
	//                                               
	If "MP8" $ oApp:cVersion                                                      
		If (Alltrim(GetTheme()) == "FLAT") .Or. SetMdiChild()                      
			nTam *= 0.90                                                            
		EndIf                                                                      
	EndIf                                                                         
Return Int(nTam)                                                                
                    

User Function EnvMail(cRecebe,cCC,cCCo,cBody,cAssunto,cAnexo)
//U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,' Importacao XML NFe entrada com Erros' ,"")

IF GetEnvServer() = "TESTE"
	RETURN(.T.)
ENDIF

Private   cServer   := GETMV("MV_RELSERV")
Private   cAccount  := GETMV("MV_RELACNT")
Private   cEnvia    := GETMV("MV_RELACNT")
Private   cPassword := GETMV("MV_RELPSW")
Private   nI        := 1
Private   cMensagem := ''
Private   cTos, CPEDIDO
Private   lEnviado ,lConectou,lDisConectou  
Private  CC :=cCC 
Private  cCC :=cCCo 
Private  cBody1 :=cBody 
Private  cAssunto1 :=cAssunto 

CONNECT SMTP SERVER cServer ACCOUNT cAccount PASSWORD cPassword Result lConectou

if GETMV("MV_RELAUTH")
	MAILAUTH(cEnvia,cPassword)
ENDIF

cArqD:=""

SEND MAIL FROM cEnvia TO cRecebe CC cCC SUBJECT cAssunto1 BODY cBody1 RESULT lEnviado

If !lEnviado
	cMensagem := ""
	GET MAIL ERROR cMensagem
	conout("Erro no envio de e-mail na importacao de XML "+cMensagem)
	cFornece := ""
Endif

DISCONNECT SMTP SERVER Result lDisConectou


return(lEnviado)    



User Function CFGMI005(nlOpc,clCodFor,clLoja,clNota,clSerie,olLBox1)

default nlOpc :=0
default clCodFor := ""
default clLoja := ""
default clNota := ""
default clSerie := ""

//ExecTela(nlOpc,clCodFor,clLoja,clNota,clSerie,olLBox1)
//Ŀ
// GERA A PRE-NOTA   
//

//VERIFICA SE ESTA RODANDO VIA MENU OU SCHEDULE

If Select("SX6") == 0
	lJob:=.T.
	lWeb := .T.
	RpcSetType(3)
	RpcSetEnv("01","01")
else
	lJob:=.F.
EndIf

dbSelectArea("SDS")
dbSetOrder(1)

if nlOpc>0
	if !msgYesNo("Deseja realmente gerar a pre-nota da NF :"+clNota+" Serie : "+clSerie )
		return
	endif
endif

Private cLJ_NFESUP:=getmv("LJ_NFESUP")
Private cEmailAdm 	:=  GETMV("MV_WFADMIN")
Private cEOL := CHR(13)+CHR(10)
Private aEmpresas:={}
Private aFilial := {}
Private cFiltro:=""

conout("Inicio da importao do XML "+DTOC(date())+" "+time())

if nlOpc > 0
	aadd(aEmpresas,{SM0->M0_CODIGO,SM0->M0_CODFIL,1})
	cFiltro+="AND DS_DOC = '"+clNota+"' "+cEol
	cFiltro+="AND DS_SERIE = '"+clSerie+"' "+cEol
	cFiltro+="AND DS_FORNEC = '"+clCodFor+"' "+cEol
	cFiltro+="AND DS_LOJA = '"+clLoja+"' "+cEol
else
	dbSelectArea("SM0")
	dbSetOrder(1)
	dbGoTop()
	While !Eof()
		if SM0->M0_CODIGO <> '03'
			aadd(aEmpresas,{SM0->M0_CODIGO,SM0->M0_CODFIL,RECNO()})
		endif
		dbSkip()
	End
endif

for ni:=1 to len(aEmpresas)
	if nlOpc=0
		RpcClearEnv()
		RpcSetType(3)
		RpcSetEnv(aEmpresas[ni,1],aEmpresas[ni,2])
		dbSelectArea("SM0")
		dbGoto(aEmpresas[ni,3])
	endif
	cQuery:="SELECT * FROM "+retSqlName("SDS")+cEol
	cQuery+="WHERE DS_STATUS=''" +cEol
	cQuery+="AND D_E_L_E_T_='' " +cEol
	cQuery+=cFiltro +cEol
	If Select("XTRB1") > 0
		XTRB1->(dbCloseArea())
	EndIf
	TcQuery cQuery new Alias "XTRB1"
	do While XTRB1->(!EOF())
		conout("inicio da rotina GerPreNf empresa "+aEmpresas[ni,1]+" filial "+XTRB1->DS_FILIAL+" "+DTOC(date())+" "+time())
		GerPreNf(aEmpresas[ni,1],XTRB1->DS_FILIAL,XTRB1->DS_FORNEC,XTRB1->DS_LOJA,XTRB1->DS_DOC,XTRB1->DS_SERIE)
		//ExecTela(nlOpc,clCodFor,clLoja,clNota,clSerie,olLBox1)
		conout("Termino da rotina empresa "+aEmpresas[ni,1]+" filial "+XTRB1->DS_FILIAL+" "+DTOC(date())+" "+time())
		XTRB1->(dbSkip())
	enddo
next ni

return


Static function GerPreNf(cEmp,cFil,clCodFor,clLoja,clNota,clSerie,lJob)
default lJob:=.F.

dbSelectArea("SDS")
dbSetOrder(1)
dbSelectArea("SD7")
dbSetOrder(1)

conout("Sistema selecionou empresa "+SM0->M0_CODIGO+" filial "+SM0->M0_CODFIL+" "+DTOC(date())+" "+time())

Begin Transaction

//Ŀ
// ALIMENTA VETORES PARA A ROTINA AUTOMATICA (MSExecAuto)   
//
alSF1:=F1Imp(clCodFor,clLoja,clNota,clSerie,"SDS")
alSD1:= D1Imp(clCodFor,clLoja,clNota,clSerie,"SDT")
llD1Imp:=if(len(alSD1) > 0,.t.,.f.)
llPedCom := .T. //VldQtdPC(alSD1)
If llD1Imp .AND. llPedCom
	lMsErroAuto := .F.
	MSExecAuto({|x,y,z| MATA140(x,y,z)},alSF1,alSD1,3 )
	
	If !lMsErroAuto
		//Ŀ
		// APOS EXECUTADA A ROTINA AUTOMATICA                 
		// ATUALIZA REGISTRO ( STATUS, DATA IMPORTACAO ...)   
		//
		dbSelectArea("SDS")
		dbSetOrder(1)
		SDS->(dbGoTop())
		If dbSeek(xFilial("SDS")+clNota+clSerie+clCodFor+clLoja)
			If RecLock("SDS",.F.)
				Replace DS_USERPRE  With cUserName
				Replace DS_DATAPRE  With dDataBase
				Replace DS_HORAPRE  With Time()
				Replace DS_STATUS   With 'P' // P = PROCESSADA PELO PROTHEUS
				SDS->(MsUnLock())
				//Aviso("Ateno", "Pr-Nota gerada com Sucesso!" ,{"Ok"})  
				cEmailErro :="Gerao de Pre-Nota:"+ENTER
				cEmailErro +="A Pre-nota de numero :"+clNota+" / "+clSerie+" foi gerada com sucesso. "+ENTER
				//ENVIA E-MAIL
				U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,'Aviso de Gerao de Pre-Nota' ,"")

			EndIf
		EndIf
	Else            
		MOSTRAERRO()
		DisarmTransaction()
		lMsErroAuto := .F.
		cEmailErro :="Gerao de Pre-Nota:"+ENTER
		cEmailErro +="Houve uma falha na gerao da Pre-nota de numero :"+clNota+" / "+clSerie+". Favor gerar manualmente. "+ENTER
		//ENVIA E-MAIL
		U_EnvMail(cLJ_NFESUP,cEmailAdm ,'',cEmailErro,'Aviso de erro na Gerao de Pre-Nota' ,"")
	EndIf
EndIf
End Transaction


return

                      
/*


ͻ
Programa  COMMI010  Autor  Microsiga            Data   11/28/12   
͹
Desc.                                                                 
                                                                      
͹
Uso        AP                                                        
ͼ

MM

User Function LeituraID()
// Variaveis Locais da Funcao
Local cIDNFE	 := SPACE(44)
Local oIDNFE
Private cIniFile	:= GetADV97()
Private cStartPath 	:= GetPvProfString(GetEnvServer(),"StartPath","ERROR", cIniFile )+'NFE\ENTRADA\'
Private cStartLido	:= Trim(cStartPath)+"ARQUIVO_XML\"
Private c2StartPath	:= Trim(cStartLido)+AllTrim(Str(Year(Date())))+"\"
Private c3StartPath	:= Trim(c2StartPath)+AllTrim(Str(Month(Date())))+"\"	//MES
Private cStartError	:= Trim(cStartPath)+"ERRO\"
Private cLJ_NFESUP:=getmv("LJ_NFESUP")       
Private cEmailAdm 	:= GETMV("MV_WFADMIN")
Private cEmailErro  := ""
//Private cEmailDes := Alltrim(GetMV("MV_EMAILE1"))+";"+Alltrim(GetMV("MV_EMAILE2"))  // E-mail do responsvel pela IMPORTACAO DE DADOS



cRetorno:="0"

// Variaveis Private da Funcao
Private oDlg				// Dialog Principal
// Variaveis que definem a Acao do Formulario

DEFINE MSDIALOG oDlg TITLE "Leitura do ID" FROM C(178),C(181) TO C(309),C(593) PIXEL

	// Cria Componentes Padroes do Sistema
	@ C(011),C(031) MsGet oIDNFE Var cIDNFE Size C(164),C(009) COLOR CLR_BLACK Picture "@!" PIXEL OF oDlg
	@ C(012),C(007) Say "ID NFE" Size C(018),C(008) COLOR CLR_BLACK PIXEL OF oDlg
	DEFINE SBUTTON FROM C(039),C(165) TYPE 1 ENABLE OF oDlg ACTION(oDlg:end())
ACTIVATE MSDIALOG oDlg CENTERED 


cquery:="select * from "+retsqlname("sds")+" "
cquery+="where DS_CHAVENF='"+cidnfe+"' "
cquery+="and D_E_L_E_T_='' "
if select("XTRB1") > 0
	XTRB1->(dbclosearea())
endif
tcquery cquery new alias "XTRB1"
nregs:=u_countqry("XTRB1")
XTRB1->(dbGotop())
if nregs > 0  .and.msgyesno("deseja gerar a prenota agora")
	conout("inicio da rotina gerprenf empresa "+sm0->m0_codigo+" filial "+sm0->m0_codfil+" "+dtoc(date())+" "+time())
	gerprenf(sm0->m0_codigo,xfilial("sds"),XTRB1->ds_fornec,XTRB1->ds_loja,XTRB1->ds_doc,XTRB1->ds_serie,.f.)
	conout("termino da rotina empresa "+sm0->m0_codigo+" filial "+xfilial("sds")+" "+dtoc(date())+" "+time())
else
	msgbox("O Id no foi encontrado para gerar pre-nota")
endif

Return(.T.)

